//+------------------------------------------------------------------+ 
//| 3LZZ_TRO_EXT                           3_Level_ZZ_Semafor.mq4    | 
//+------------------------------------------------------------------+ 
//| 3LZZ_TRO_EXT                          |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
 
#property copyright "asystem2000" 
#property link      "asystem2000@yandex.ru" 

#property indicator_chart_window 
#property indicator_buffers 7
#property indicator_color1 Chocolate 
 
//+--------- TRO MODIFICATION ---------------------------------------+ 

 
//---- input parameters 

extern double Period1=5; 
extern double Period2=13; 
extern double Period3=34; 

extern string   Dev_Step_1="1,3";
extern string   Dev_Step_2="8,5";
extern string   Dev_Step_3="13,8";
 

//---- buffers 
double FP_BuferUp[];
double FP_BuferDn[]; 
double NP_BuferUp[];
double NP_BuferDn[]; 
double HP_BuferUp[];
double HP_BuferDn[]; 
double TheBuffer[]; 

int F_Period;
int N_Period;
int H_Period;
int Dev1;
int Stp1;
int Dev2;
int Stp2;
int Dev3;
int Stp3; 
//+------------------------------------------------------------------+ 
int init() 
  {  
  
// ---------     
  
  
   if (Period1>0) F_Period=MathCeil(Period1*Period()); else F_Period=0; 
   if (Period2>0) N_Period=MathCeil(Period2*Period()); else N_Period=0; 
   if (Period3>0) H_Period=MathCeil(Period3*Period()); else H_Period=0; 
   
//----  1  
   if (Period1>0)
   {
   SetIndexStyle(0,DRAW_NONE,0,1); 
 
   SetIndexBuffer(0,FP_BuferUp); 
 
   
   SetIndexStyle(1,DRAW_NONE,0,1); 
 
   SetIndexBuffer(1,FP_BuferDn); 
 
   }
   
//----  2  
   if (Period2>0)
   {
   SetIndexStyle(2,DRAW_NONE,0,2); 
 
   SetIndexBuffer(2,NP_BuferUp); 
 
   
   SetIndexStyle(3,DRAW_NONE,0,2); 
  
   SetIndexBuffer(3,NP_BuferDn); 
 
   }
//----  3  
   if (Period3>0)
   {
   SetIndexStyle(4,DRAW_NONE,0,4); 
  
   SetIndexBuffer(4,HP_BuferUp); 
 

   SetIndexStyle(5,DRAW_NONE,0,4); 
 
   SetIndexBuffer(5,HP_BuferDn); 
 
   }
   

   SetIndexStyle(6,DRAW_LINE ); 
   SetIndexBuffer(6,TheBuffer) ;
 
   
   
   
//     
   int CDev=0;
   int CSt=0;
   int Mass[]; 
   int C=0;  
   if (IntFromStr(Dev_Step_1,C, Mass)==1) 
      {
        Stp1=Mass[1];
        Dev1=Mass[0];
      }
   
   if (IntFromStr(Dev_Step_2,C, Mass)==1)
      {
        Stp2=Mass[1];
        Dev2=Mass[0];
      }      
   
   
   if (IntFromStr(Dev_Step_3,C, Mass)==1)
      {
        Stp3=Mass[1];
        Dev3=Mass[0];
      }      
   return(0); 
  } 
  
//+------------------------------------------------------------------+ 
int deinit() 
  { 

   return(0); 
  } 
 
//+------------------------------------------------------------------+ 
int start() 
  { 

   if (Period1>0) CountZZ(FP_BuferUp,FP_BuferDn,Period1,Dev1,Stp1);
   if (Period2>0) CountZZ(NP_BuferUp,NP_BuferDn,Period2,Dev2,Stp2);
   if (Period3>0) CountZZ(HP_BuferUp,HP_BuferDn,Period3,Dev3,Stp3);
   
   
   
   
   while(true)
   {  
      if(HP_BuferUp[0] != 0 ) { TheBuffer[0] = -3 ; break ; }
      if(HP_BuferDn[0] != 0 ) { TheBuffer[0] =  3 ; break ; }  
      if(NP_BuferUp[0] != 0 ) { TheBuffer[0] = -2 ; break ; }
      if(NP_BuferDn[0] != 0 ) { TheBuffer[0] =  2 ; break ; }   
      if(FP_BuferUp[0] != 0 ) { TheBuffer[0] = -1 ; break ; }
      if(FP_BuferDn[0] != 0 ) { TheBuffer[0] =  1 ; break ; }      
      
      TheBuffer[0] = 0 ; break ;
   }    
             
   return(0);
} 
//+------------------------------------------------------------------+ 
//  
//int Take



//+------------------------------------------------------------------+ 
//|                           | 
//+------------------------------------------------------------------+  
int CountZZ( double& ExtMapBuffer[], double& ExtMapBuffer2[], int ExtDepth, int ExtDeviation, int ExtBackstep )
  {
   int    shift, back,lasthighpos,lastlowpos, LIMIT ;
   double val,res;
   double curlow,curhigh,lasthigh,lastlow;

   LIMIT = 100 ;

//  Comment(Symbol(), Period(),   "\n" , " BARS= ", LIMIT ) ;

   for(shift=LIMIT-ExtDepth; shift>=0; shift--)
     {
      val=Low[Lowest(NULL,0,MODE_LOW,ExtDepth,shift)];
      if(val==lastlow) val=0.0;
      else 
        { 
         lastlow=val; 
         if((Low[shift]-val)>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ExtMapBuffer[shift+back];
               if((res!=0)&&(res>val)) ExtMapBuffer[shift+back]=0.0; 
              }
           }
        } 
        
          ExtMapBuffer[shift]=val;
      //--- high
      val=High[Highest(NULL,0,MODE_HIGH,ExtDepth,shift)];
      if(val==lasthigh) val=0.0;
      else 
        {
         lasthigh=val;
         if((val-High[shift])>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ExtMapBuffer2[shift+back];
               if((res!=0)&&(res<val)) ExtMapBuffer2[shift+back]=0.0; 
              } 
           }
        }
      ExtMapBuffer2[shift]=val;
     }
   // final cutting 
   lasthigh=-1; lasthighpos=-1;
   lastlow=-1;  lastlowpos=-1;

   for(shift=LIMIT-ExtDepth; shift>=0; shift--)
     {
      curlow=ExtMapBuffer[shift];
      curhigh=ExtMapBuffer2[shift];
      if((curlow==0)&&(curhigh==0)) continue;
      //---
      if(curhigh!=0)
        {
         if(lasthigh>0) 
           {
            if(lasthigh<curhigh) ExtMapBuffer2[lasthighpos]=0;
            else ExtMapBuffer2[shift]=0;
           }
         //---
         if(lasthigh<curhigh || lasthigh<0)
           {
            lasthigh=curhigh;
            lasthighpos=shift;
           }
         lastlow=-1;
        }
      //----
      if(curlow!=0)
        {
         if(lastlow>0)
           {
            if(lastlow>curlow) ExtMapBuffer[lastlowpos]=0;
            else ExtMapBuffer[shift]=0;
           }
         //---
         if((curlow<lastlow)||(lastlow<0))
           {
            lastlow=curlow;
            lastlowpos=shift;
           } 
         lasthigh=-1;
        }
     }
  
   for(shift=LIMIT-1; shift>=0; shift--)
     {
      if(shift>=LIMIT-ExtDepth) ExtMapBuffer[shift]=0.0;
      else
        {
         res=ExtMapBuffer2[shift];
         if(res!=0.0) ExtMapBuffer2[shift]=res;
        }
     }
 return(0) ;
 }

//+------------------------------------------------------------------+   
int Str2Massive(string VStr, int& M_Count, int& VMass[])
  {
    int val=StrToInteger( VStr);
    if (val>0)
       {
         M_Count++;
         int mc=ArrayResize(VMass,M_Count);
         if (mc==0)return(-1);
          VMass[M_Count-1]=val;
         return(1);
       }
    else return(0);    
  } 
  

//+------------------------------------------------------------------+   
int IntFromStr(string ValStr,int& M_Count, int& VMass[])
  {
    
    if (StringLen(ValStr)==0) return(-1);
    string SS=ValStr;
    int NP=0; 
    string CS;
    M_Count=0;
    ArrayResize(VMass,M_Count);
    while (StringLen(SS)>0)
      {
            NP=StringFind(SS,",");
            if (NP>0)
               {
                 CS=StringSubstr(SS,0,NP);
                 SS=StringSubstr(SS,NP+1,StringLen(SS));  
               }
               else
               {
                 if (StringLen(SS)>0)
                    {
                      CS=SS;
                      SS="";
                    }
               }
            if (Str2Massive(CS,M_Count,VMass)==0) 
               {
                 return(-2);
               }
      }
    return(1);    
  }
  

//+------------------------------------------------------------------+

/*
if(Symbol() == "USDJPY" && Period() == 60)
{
Comment(
Symbol(), Period(),   "\n" ,  
"FP_BuferUp[0] " , DoubleToStr( FP_BuferUp[0] ,Digits) , "\n" ,   
"FP_BuferDn[0] " , DoubleToStr( FP_BuferDn[0] ,Digits) , "\n" , 

"NP_BuferUp[0] " , DoubleToStr( NP_BuferUp[0] ,Digits) , "\n" ,   
"NP_BuferDn[0] " , DoubleToStr( NP_BuferDn[0] ,Digits) , "\n" ,   

"HP_BuferUp[0] " , DoubleToStr( HP_BuferUp[0] ,Digits) , "\n" ,   
"HP_BuferDn[0] " , DoubleToStr( HP_BuferDn[0] ,Digits) , "\n" , 
 
"TheBuffer[0] " , DoubleToStr(TheBuffer[0],Digits) , "\n" ,   

 
"") ; 
}      
  
      
*/   