//+------------------------------------------------------------------+
//|                                                 DSS Bressert.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| DSS Bressert_TRO_MODIFIED_VERSION                                |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 DarkBlue
#property indicator_level1 20
#property indicator_level2 80
#property indicator_level3 90
#property indicator_level4 10


extern bool Sound_Alert = true ;
extern bool Show_Message = true ;

extern int myCorner= 1;
extern int x_offset= 80 ; 
extern int y_offset= 10 ; 


extern string myFont       = "Arial Bold" ;
extern int    myFontSize   = 20 ;


extern color colorOverSold   = Blue ;
extern color colorOverBought = Red ;

extern color colorUp  =  Aqua ;
//extern color colorxUp =  Blue ;
extern color colorEq  =  DimGray ;
//extern color colorxDn =  Magenta ;
extern color colorDn  =  Magenta ;
 

//---- input parameters
extern int       EMA_period=8;
extern int       Stochastic_period=13;


extern int OverSold   = 20 ;
extern int OverBought = 80 ;


//---- buffers
double DssBuffer[];
double MitBuffer[];

double smooth_coefficient;


int    digits2, digits, period, win , xInc, yInc, xPos, yPos  ; 
string short_name;
 
string symbol, tChartPeriod, tAlert, tObjName06 ; 
double   point ;    
color colorPrice ;
datetime Trigger ;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   period       =  Period() ;  
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; } 
  

   SetLevelStyle(STYLE_DOT, 1, DimGray) ;
   SetLevelValue(1,90);
   SetLevelValue(2,80);   
   SetLevelValue(3,50);
   SetLevelValue(4,20);
   SetLevelValue(5,10);
 

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,DssBuffer);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,MitBuffer);
   
   SetIndexEmptyValue(0, 0.0);
   SetIndexLabel(0, "DSS");
   SetIndexEmptyValue(1, 0.0);
   SetIndexLabel(1, "MIT");

   short_name = "DSS("+EMA_period+","+Stochastic_period+")";

   IndicatorShortName (short_name);

   smooth_coefficient = 2.0 / (1.0 + EMA_period);
   
      
   
      tObjName06 = short_name + "06" ; 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
  
   win =    WindowFind(short_name);
    
  
   int i, limit, counted_bars=IndicatorCounted();
//----
   if (counted_bars == 0)   limit = Bars - Stochastic_period;
   if (counted_bars > 0)   limit = Bars - counted_bars;
   
   double HighRange, LowRange;
   double delta, MIT;
   for (i = limit; i >= 0; i--)
      {
      HighRange = High[iHighest(NULL,0,MODE_HIGH,Stochastic_period,i)];
      LowRange = Low[iLowest(NULL,0,MODE_LOW,Stochastic_period,i)];
      delta = Close[i] - LowRange;
      MIT = delta/(HighRange - LowRange)*100.0;
      MitBuffer[i] = smooth_coefficient * (MIT - MitBuffer[i+1]) + MitBuffer[i+1];
      }

   double DSS;
   for (i = limit; i >= 0; i--)
      {
      HighRange = MitBuffer[ArrayMaximum(MitBuffer, Stochastic_period, i)];
      LowRange = MitBuffer[ArrayMinimum(MitBuffer, Stochastic_period, i)];
      delta = MitBuffer[i] - LowRange;
      DSS = delta/(HighRange - LowRange)*100.0;
      DssBuffer[i] = smooth_coefficient * (DSS - DssBuffer[i+1]) + DssBuffer[i+1];
      }
      
//----
   
   if(  Show_Message ) { DoShow() ; }

   return(0);
  }

//+------------------------------------------------------------------+

void DoShow()
{
   
   yInc = myFontSize + 5 ;
   yPos = 0 ;
 
   while(true)
   {  
 
   if(DssBuffer[0] > OverBought || MitBuffer[0] > OverBought ) 
   { 
      colorPrice = colorOverBought ;
      tAlert     = tChartPeriod + " Over Bought " ; 
      break ;
   }

   if(DssBuffer[0] < OverSold || MitBuffer[0] < OverSold ) 
   { 
      colorPrice = colorOverSold ;
      tAlert     = tChartPeriod + " Over Sold " ; 
      break ;
   }
   
   if(DssBuffer[0] > DssBuffer[1] && MitBuffer[0] > MitBuffer[1] ) 
   { 
      colorPrice = colorUp ;
      tAlert     = tChartPeriod + " Bullish " ; 
      break ;
   } 
       
   if(DssBuffer[0] < DssBuffer[1] && MitBuffer[0] < MitBuffer[1] ) 
   { 
      colorPrice = colorDn ;
      tAlert     = tChartPeriod +  " Bearish " ; 
      break ;
   }  
  
      colorPrice = colorEq ;
      tAlert     = " No Direction  " ; 
      break ;
  
   } 

   
   ObjectCreate(tObjName06, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName06, tAlert , myFontSize, myFont, colorPrice );  
   ObjectSet(tObjName06, OBJPROP_CORNER, 1);
   ObjectSet(tObjName06, OBJPROP_XDISTANCE,  x_offset); // myCorner
   ObjectSet(tObjName06, OBJPROP_YDISTANCE,  y_offset); //     


}    
      
//+------------------------------------------------------------------+ 

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
//+------------------------------------------------------------------+  
/*


   
   yInc = myFontSize + 5 ;
   yPos = 0 ;
 
   while(true)
   {  
 
   if(MitBuffer[0] > DssBuffer[0] && MitBuffer[1] < DssBuffer[1]) 
   { 
      colorPrice = colorxUp ;
      tAlert     = tChartPeriod + " Bullish Cross" ; 
      if ( Trigger != Time[0] &&  Sound_Alert ) 
      {
         Trigger = Time[0] ; 
         Alert(symbol,"  ", tChartPeriod, " Bullish Cross " ) ;  
      }

      break ;
   } 
    
   if(MitBuffer[0] < DssBuffer[0] && MitBuffer[1] > DssBuffer[1]) 
   {  
      colorPrice = colorxDn ;
      tAlert     = tChartPeriod + " Bearish Cross" ; 
      if ( Trigger != Time[0] &&  Sound_Alert ) 
      {
         Trigger = Time[0] ; 
         Alert(symbol,"  ", tChartPeriod, " Bearish Cross " ) ;  
      }
      break ;
   }
   
   if(MitBuffer[0] > DssBuffer[0]  ) 
   { 
      colorPrice = colorxUp ;
      tAlert     = tChartPeriod + " Bullish " ; 
      break ;
   } 
       
   if(MitBuffer[0] < DssBuffer[0] ) 
   { 
      colorPrice = colorDn ;
      tAlert     = tChartPeriod +  " Bearish " ; 
      break ;
   }  
  
      colorPrice = colorEq ;
      tAlert     = "No Directional" ; 
      break ;
  
   } 

//+------------------------------------------------------------------+ 

   if(DssBuffer[0] > MitBuffer[0] && DssBuffer[1] < MitBuffer[1]) 
   { 
      colorPrice = colorxUp ;
      tAlert     = tChartPeriod + " Bullish Cross" ; 
      if ( Trigger != Time[0] &&  Sound_Alert ) 
      {
         Trigger = Time[0] ; 
         Alert(symbol,"  ", tChartPeriod, " Bullish Cross " ) ;  
      }

      break ;
   } 
    
   if(DssBuffer[0] < MitBuffer[0] && DssBuffer[1] > MitBuffer[1]) 
   {  
      colorPrice = colorxDn ;
      tAlert     = tChartPeriod + " Bearish Cross" ; 
      if ( Trigger != Time[0] &&  Sound_Alert ) 
      {
         Trigger = Time[0] ; 
         Alert(symbol,"  ", tChartPeriod, " Bearish Cross " ) ;  
      }
      break ;
   }
   
   if(DssBuffer[0] > MitBuffer[0]  ) 
   { 
      colorPrice = colorxUp ;
      tAlert     = tChartPeriod + " Bullish " ; 
      break ;
   } 
       
   if(DssBuffer[0] < MitBuffer[0] ) 
   { 
      colorPrice = colorDn ;
      tAlert     = tChartPeriod +  " Bearish " ; 
      break ;
   }  
  
      colorPrice = colorEq ;
      tAlert     = "No Direction" ; 
      break ;
  
   } 



*/

