//*
//* my_DailyOpen_indicator
//*
//* Revision 1.1  2005/11/13 Midnite
//* Initial DailyOpen indicator
//* based pm  
//+------------------------------------------------------------------+
//| Daily open line_TRO_MODIFIED                             |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
 

#property copyright "Midnite"
#property link      "me@home.net"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 White
#property indicator_style1 2
#property indicator_width1 1

extern bool SHOW_BOXES     = true ;

extern int myBoxSize       = 1 ;  


extern bool SHOW_LABELS    = true ;
extern string myLineLabel = "Open";

extern int TimeZoneOfData= 0;
extern int myLineStyle = 2;
extern int myLineWidth = 1;
extern color myLineColor = Orange;

double TodayOpenBuffer[];
string TAG ;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
	SetIndexStyle(0,DRAW_LINE,myLineStyle,myLineWidth,myLineColor); 
	SetIndexBuffer(0,TodayOpenBuffer);
	SetIndexLabel(0,"Open");
	SetIndexEmptyValue(0,0.0);
	
	TAG = "dol"+TimeZoneOfData;
	deinit();
	
	return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
	ObjectDelete(TAG);
	TRO();
	
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int lastbar;
   int counted_bars= IndicatorCounted();
   
   if (counted_bars>0) counted_bars--;
   lastbar = Bars-counted_bars;	  
   
   DailyOpen(0,lastbar);
   
   return (0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int DailyOpen(int offset, int lastbar)
{
   int shift;
   int tzdiffsec= TimeZoneOfData * 3600;
   double barsper30= 1.0*PERIOD_M30/Period();
   bool ShowDailyOpenLevel= True;
   // lastbar+= barsperday+2;  // make sure we catch the daily open		 
   lastbar= MathMin(Bars-20*barsper30-1, lastbar);


	for(shift=lastbar;shift>=offset;shift--){
	  TodayOpenBuffer[shift]= 0;
     if (ShowDailyOpenLevel){
       if(TimeDay(Time[shift]-tzdiffsec) != TimeDay(Time[shift+1]-tzdiffsec)){      // day change
         TodayOpenBuffer[shift]= Open[shift];         
         TodayOpenBuffer[shift+1]= 0;                                                           // avoid stairs in the line
       }
       else{
         TodayOpenBuffer[shift]= TodayOpenBuffer[shift+1];
       }
	  }
   }

    

   if(SHOW_LABELS)
   {         
      string Obj0002 = "linelbl"+TimeZoneOfData ;

     int Chart_Scale  ,Bar_Width  ;      
     Chart_Scale = ChartScaleGet();
     
     //Set bar widths             
           if(Chart_Scale == 0) {Bar_Width = 120;}
     else {if(Chart_Scale == 1) {Bar_Width = 60;}      
     else {if(Chart_Scale == 2) {Bar_Width = 30;}
     else {if(Chart_Scale == 3) {Bar_Width = 15;}
     else {if(Chart_Scale == 4) {Bar_Width = 8;}
     else {Bar_Width = 5;} }}}}

 
     datetime LabelTime = Time[0]+Period()*60*Bar_Width ; // Time[WindowFirstVisibleBar()/2]; // Time[0]+Period()*60*ShiftLabel ;   
    
      
      ObjectDelete(Obj0002);
      
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, LabelTime, TodayOpenBuffer[0]);
         ObjectSetText(Obj0002,fFill(myLineLabel+" " +TimeZoneOfData+":00",22) , 8, "Terminal", myLineColor);
      }
      else
      {
         ObjectMove(Obj0002, 0, LabelTime, TodayOpenBuffer[0]);
      } // if 
                 
   } // if     
   

   
   if(SHOW_BOXES)
   {
      drawBox(TodayOpenBuffer[0],"Hr["+TimeZoneOfData+"]", myLineColor ) ;
   }
   
   return(0);
}
//+------------------------------------------------------------------+
 
void drawBox(double lvl,string name, color Col  )
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_ARROW, 0, Time[0], lvl,Time[0],lvl);
            ObjectSet(name,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,myBoxSize);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_ARROW, 0, Time[0], lvl,Time[0],lvl);
            ObjectSet(name,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);              
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,myBoxSize);
          
         }
 
}
//+-------------------------------------------------------------------------------------------+
//| Subroutine:  Get the chart scale number                                                   |
//+-------------------------------------------------------------------------------------------+
int ChartScaleGet()
  {
  long result = -1;
  ChartGetInteger(0,CHART_SCALE,0,result);
  return((int)result);
  } 
//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}
 
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 
/*

   
Comment(
"Bars = " , Bars , "\n" ,   
"counted_bars = " , counted_bars , "\n" ,   
"lastbar = " , lastbar , "\n" ,       
"") ; 
 
 
*/