//+------------------------------------------------------------------+
//|    Fiboossss_TRO_MODIFIED_VERSION                      Fibos.mq4 |
//|                                        Developed by Coders' Guru |
//|                                            http://www.xpworx.com |
//+------------------------------------------------------------------+
//| _TRO_MODIFIED_VERSION                                  |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
 
 
#property copyright "Coders' Guru"
#property link      "http://www.xpworx.com"
string   ver  = "Last Modified: 2008.02.22 19:20";

#property indicator_chart_window
#property  indicator_buffers 7

extern bool   TurnOff       = false ; 
extern bool   SHOW_Comment  = true ;

//extern bool  Higher_To_Lower  = true;    //else Lower_To_Higher
extern bool  DrawVerticalLines = false;
extern int   StartBar = 0;
extern int   BarsBack = 0;
extern color FiboColor=Orange ;
extern int   FiboStyle=STYLE_DOT ;
extern int   LineStyle=0 ;
extern int   LineWidth=1;
extern color LineColor=Orange ;

double f_1[];
double f_2[];

double RANGE, PCT, CLOSE ;

int     digits ; 
double point   ; 

int limit ;
//+------------------------------------------------------------------+

void DeleteAllObjects()
{
   int objs = ObjectsTotal();
   string name;
   for(int cnt=ObjectsTotal()-1;cnt>=0;cnt--)
   {
      name=ObjectName(cnt);
      if (StringFind(name,"V_",0)>-1) ObjectDelete(name);
      if (StringFind(name,"H_",0)>-1) ObjectDelete(name);
      if (StringFind(name,"f_",0)>-1) ObjectDelete(name);
      if (StringFind(name,"fib",0)>-1) ObjectDelete(name);
      if (StringFind(name,"trend",0)>-1) ObjectDelete(name);
      
   }
   WindowRedraw();
}

//+------------------------------------------------------------------+
void CalcFibo()
{
  
  DeleteAllObjects();

   if(BarsBack == 0) { limit = WindowBarsPerChart() ;  } else { limit = BarsBack ; }
 

  
  int lowest_bar = iLowest(NULL,0,MODE_LOW,limit,StartBar);
  int highest_bar = iHighest(NULL,0,MODE_HIGH,limit,StartBar);
  
  double higher_point = 0;
  double lower_point = 0;
  higher_point=High[highest_bar];
  lower_point=Low[lowest_bar];
  
  
   RANGE = higher_point - lower_point ;
   PCT   = 100 * ( Close[0] -  lower_point) / RANGE ;

   if(SHOW_Comment)
   {
      Comment( 
      "FIB HIGH = ", DoubleToStr(higher_point , digits), "\n",        
      "FIB LOW = ", DoubleToStr(lower_point , digits), "\n", 
      "FIB RANGE= ", DoubleToStr(RANGE / point  , 0), "\n",   
      "FIB % IN RANGE= ", DoubleToStr(PCT  , 2), "\n",  
      "") ;
   }
  
  if(DrawVerticalLines) DrawVerticalLine("V_UPPER",highest_bar,LineColor);
  if(DrawVerticalLines) DrawVerticalLine("V_LOWER",lowest_bar,LineColor);
  
  int i = 0;
  
//  if(Higher_To_Lower)
  if( higher_point > lower_point )
  {
      for(i = 0; i < 500; i++)
      {
         f_1[i] = higher_point;
         f_2[i] = lower_point;
      }
      ObjectCreate("fib",OBJ_FIBO,0,0,higher_point,0,lower_point);
      ObjectSet("fib",OBJPROP_STYLE,STYLE_DOT);
      ObjectSet("fib",OBJPROP_LEVELCOLOR,FiboColor);
      ObjectSet("fib",OBJPROP_LEVELSTYLE,FiboStyle);
      
      ObjectSet("fib",OBJPROP_FIBOLEVELS,7);
      if(!ObjectSet("fib",OBJPROP_FIRSTLEVEL+0,0.000)) Print("?????? ????????? ?????? 3 Fibo1 ",GetLastError());      
      if(!ObjectSet("fib",OBJPROP_FIRSTLEVEL+1,0.236)) Print("?????? ????????? ?????? 4 Fibo1 ",GetLastError());      
      if(!ObjectSet("fib",OBJPROP_FIRSTLEVEL+2,0.382)) Print("?????? ????????? ?????? 1 Fibo1 ",GetLastError());
      if(!ObjectSet("fib",OBJPROP_FIRSTLEVEL+3,0.50)) Print("?????? ????????? ?????? 2 Fibo1 ",GetLastError());
      if(!ObjectSet("fib",OBJPROP_FIRSTLEVEL+4,0.618)) Print("?????? ????????? ?????? 3 Fibo1 ",GetLastError());
      if(!ObjectSet("fib",OBJPROP_FIRSTLEVEL+5,0.764)) Print("?????? ????????? ?????? 4 Fibo1 ",GetLastError());
      if(!ObjectSet("fib",OBJPROP_FIRSTLEVEL+6,1.000)) Print("?????? ????????? ?????? 3 Fibo1 ",GetLastError());
      ObjectSetFiboDescription( "fib", 0,"0.0");       
      ObjectSetFiboDescription( "fib", 1,"23.6"); 
      ObjectSetFiboDescription( "fib", 2,"38.2"); 
      ObjectSetFiboDescription( "fib", 3,"50.0"); 
      ObjectSetFiboDescription( "fib", 4,"61.8");      
      ObjectSetFiboDescription( "fib", 5,"76.4");  
      ObjectSetFiboDescription( "fib", 6,"100.0"); 
                  
      ObjectCreate("trend",OBJ_TREND,0,Time[highest_bar],higher_point,Time[lowest_bar],lower_point);
      ObjectSet("trend",OBJPROP_STYLE,STYLE_DOT);
      ObjectSet("trend",OBJPROP_RAY,false);
  }
  else
  {
      for(i = 0; i < 500; i++)
      {
         f_1[i] = higher_point;
         f_2[i] = lower_point;
      }
      DeleteAllObjects();
      ObjectCreate("fib",OBJ_FIBO,0,0,higher_point,0,lower_point);
      ObjectSet("fib",OBJPROP_STYLE,STYLE_DOT);
      ObjectSet("fib",OBJPROP_LEVELCOLOR,FiboColor);
      ObjectSet("fib",OBJPROP_LEVELSTYLE,FiboStyle);
      
      ObjectSet("fib",OBJPROP_FIBOLEVELS,7);
      if(!ObjectSet("fib",OBJPROP_FIRSTLEVEL+0,0.000)) Print("?????? ????????? ?????? 3 Fibo1 ",GetLastError());      
      if(!ObjectSet("fib",OBJPROP_FIRSTLEVEL+1,0.236)) Print("?????? ????????? ?????? 4 Fibo1 ",GetLastError());      
      if(!ObjectSet("fib",OBJPROP_FIRSTLEVEL+2,0.382)) Print("?????? ????????? ?????? 1 Fibo1 ",GetLastError());
      if(!ObjectSet("fib",OBJPROP_FIRSTLEVEL+3,0.50)) Print("?????? ????????? ?????? 2 Fibo1 ",GetLastError());
      if(!ObjectSet("fib",OBJPROP_FIRSTLEVEL+4,0.618)) Print("?????? ????????? ?????? 3 Fibo1 ",GetLastError());
      if(!ObjectSet("fib",OBJPROP_FIRSTLEVEL+5,0.764)) Print("?????? ????????? ?????? 4 Fibo1 ",GetLastError());
      if(!ObjectSet("fib",OBJPROP_FIRSTLEVEL+6,1.000)) Print("?????? ????????? ?????? 3 Fibo1 ",GetLastError());
      ObjectSetFiboDescription( "fib", 0,"0.0");       
      ObjectSetFiboDescription( "fib", 1,"23.6"); 
      ObjectSetFiboDescription( "fib", 2,"38.2"); 
      ObjectSetFiboDescription( "fib", 3,"50.0"); 
      ObjectSetFiboDescription( "fib", 4,"61.8");      
      ObjectSetFiboDescription( "fib", 5,"76.4");  
      ObjectSetFiboDescription( "fib", 6,"100.0");       
      
      ObjectCreate("trend",OBJ_TREND,0,Time[lowest_bar],lower_point,Time[highest_bar],higher_point);
      ObjectSet("trend",OBJPROP_STYLE,STYLE_DOT);
      ObjectSet("trend",OBJPROP_RAY,false);
  }
  
  
}
//+------------------------------------------------------------------+

void DrawVerticalLine(string name , int bar , color clr)
{
   if(ObjectFind(name)==false)
   {
      ObjectCreate(name,OBJ_VLINE,0,Time[bar],0);
      ObjectSet(name,OBJPROP_COLOR,clr);
      ObjectSet(name,OBJPROP_WIDTH,LineWidth);
      ObjectSet(name,OBJPROP_STYLE,LineStyle);

   }
   else
   {
      ObjectDelete(name);
      ObjectCreate(name,OBJ_VLINE,0,Time[bar],0);
      ObjectSet(name,OBJPROP_COLOR,clr);
      ObjectSet(name,OBJPROP_WIDTH,LineWidth);
      ObjectSet(name,OBJPROP_STYLE,LineStyle);

   }
      WindowRedraw();
}

//+------------------------------------------------------------------+

int deinit()
{
   DeleteAllObjects();
   Comment("") ;
   
   TRO();
   
   return (0);
}

//+------------------------------------------------------------------+

int init()
{

   digits       =  Digits ;
   point        =  Point ;
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
  
  DeleteAllObjects();
  SetIndexBuffer(0,f_1);
  SetIndexBuffer(1,f_2);
  
  return(0);
}

//+------------------------------------------------------------------+
int start()
{
  
  if( TurnOff ) { return(0) ; }
  
  CalcFibo();
  
  
  return(0);
}
//+------------------------------------------------------------------+
 
void TRO()
{   

   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}
  
//+------------------------------------------------------------------+




