//+------------------------------------------------------------------+
//| Magnified Market Price.mq4        ver1.4             by Habeeb   |
//+------------------------------------------------------------------+
//| Magnified Market Price_TRO_MODIFIED_VERSION                      |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window

extern bool TURN_OFF                      = false ;
extern bool Show_Symbol                   = True ;
extern bool Show_ChartPeriod              = True ;
extern bool Show_Discount                 = false ;
extern bool Show_FibRetrace               = false ;
extern bool Show_GPS                      = True;
extern bool Show_PercentChange            = false;
extern bool Show_ATR_Percent_from_open    = false;

input ENUM_TIMEFRAMES   myPeriod = 1440 ; // myPeriod
extern int  barsToCount   = 52 ;
extern int  ATR_PERIOD    = 14 ;


extern string FontType="Arial Bold" ; //"Comic Sans MS";
extern string note5 = "Display the price in what corner?";
extern string note6 = "Upper left=0; Upper right=1";
extern string note7 = "Lower left=2; Lower right=3";
extern int    WhatCorner=0;
extern int    xAxis = 250;
extern int    yAxis = 1;
extern string note3 = "Font Size";
extern int    FontSize=20;
extern string note4 = "Font Type";

extern string note1 = "Change font colors automatically? True = Yes";
extern bool   Bid_Ask_Colors = True;
extern string note2 = "Default Font Color";
extern color  FontColor   = Blue;
extern color  FontColorUp = Lime;  
extern color  FontColorDn = Red;   


string        symbol , tChartPeriod , fibChartPeriod , gpsChartPeriod , Market_Price  , Market_Price2 ;
double        Old_Price, point, ATR ;

int     digits, period, win, digits2, n, j, i, k;

double open, high, low, close, mid, range , value ;  
double diff, space , pct, fibpct, clop, cllo, hicl;

int nHH, nLL; 

//+------------------------------------------------------------------+

int init()
  {
   symbol       =  Symbol() ; 
   digits       =  Digits ;
   point        =  Point ;

   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }    
   
   tChartPeriod   = TimeFrameToString(Period()) ;
   
   fibChartPeriod = TimeFrameToString(period) ;
    
    
   if(digits == 5 || digits == 3) { digits  = digits - 1 ; point = point * 10 ; } 
 
   TRO();
   return(0);
  }

//+------------------------------------------------------------------+

int deinit()
  {
  ObjectDelete("Market_Price_Label"); 
  ObjectDelete("Market_Price_Label2"); 
  ObjectDelete("Market_Price_Label3");   
  TRO();
  return(0);
  }

//+------------------------------------------------------------------+

int start()
{
 if( TURN_OFF ) { deinit(); return(0) ; }
 
 Market_Price  = "" ;
 Market_Price2 = "" ;
   
 close    = iClose( symbol, period, 0) ;
 open     = iOpen( symbol, period, 0) ;

 nHH      =  Highest(NULL,PERIOD_W1,MODE_HIGH,barsToCount,0); 
 nLL      =  Lowest(NULL,PERIOD_W1,MODE_LOW,barsToCount,0); 
 
 high     = iHigh( symbol, PERIOD_W1, nHH) ;
 low      = iLow( symbol, PERIOD_W1, nLL) ;

 range    = high - low ;

 diff     = high - close ;
 if(diff > 0) {pct = 100 * diff / high ; }
  
  
 diff     = iHigh( symbol,period , 0) - iLow( symbol,period , 0) ;
 if(diff > 0) { fibpct   = 100 * ( close - iLow( symbol,period , 0) ) / ( diff  ) ; } else { fibpct  = 0 ; }
  

  
   if (Bid_Ask_Colors == True)
   {
    if (Bid > Old_Price) FontColor = FontColorUp;
    if (Bid < Old_Price) FontColor = FontColorDn;
    Old_Price = Bid;
   }
   else
   {
    if (close > open) FontColor = FontColorUp;
    if (close < open) FontColor = FontColorDn;
   }   
 
 
   
   
   if(Show_ChartPeriod) { Market_Price = tChartPeriod + " " ; } 
   if(Show_Symbol) { Market_Price = Market_Price + StringSubstr(Symbol(),0,6) + " " ; }  
   
   Market_Price = Market_Price + DoubleToStr(Bid, digits) + " "  ;
   
   if( Show_FibRetrace ) 
   { 
      Market_Price = Market_Price + " " + DoubleToStr(fibpct, 2) + " f%-"+fibChartPeriod ; 
   }
   
   if( Show_Discount ) { Market_Price = Market_Price + " " + DoubleToStr(pct, 2) + " d%" ; }
   
   
   if( Show_GPS ) 
   { 
       open     = iOpen( symbol, period, 0) ;
       high     = iHigh( symbol, myPeriod, 0) ;
       low      = iLow( symbol, myPeriod, 0) ;
       
       clop     = (close - open) / point ;
       cllo     = (close - low) / point ;
       hicl     = (high - close) / point ;
       
      Market_Price2 = " " + fibChartPeriod 
                                  + " ClOp= " + DoubleToStr(clop, 0) 
                                  + " HiCl= " + DoubleToStr(hicl, 0) 
                                  + " ClLo= " + DoubleToStr(cllo, 0); 
   }

   if(Show_PercentChange)
   {       
       value = 100.0 * ((iClose(symbol,0,0)/iOpen(symbol,myPeriod,0))-1.0)  ;
       Market_Price2 = Market_Price2 + " " + fibChartPeriod  + " %Chg= " + DoubleToStr(value, 2);    
   }

   if( Show_ATR_Percent_from_open ) 
   { 
   
      open     = iOpen( symbol, period, 0) ;
      close   = iClose(symbol, period, 0) ;   
   
      ATR     = iATR(symbol,period,ATR_PERIOD,0);
      
      diff    = (close - open);
      
      diff    = 100 * diff / ATR ;
      
      Market_Price2 = Market_Price2 +  " ATR("+ATR_PERIOD+") OP%= " + rtadjust(DoubleToStr(diff,0),4);   
   
   }


// Comment( "MP="+StringLen(Market_Price)," MP2="+StringLen(Market_Price2)," xAxis="+xAxis," FontSize="+FontSize );
 
   ObjectCreate("Market_Price_Label", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Market_Price_Label", Market_Price, FontSize, FontType, FontColor);
   ObjectSet("Market_Price_Label", OBJPROP_CORNER, WhatCorner);
   ObjectSet("Market_Price_Label", OBJPROP_XDISTANCE, xAxis);
   ObjectSet("Market_Price_Label", OBJPROP_YDISTANCE, yAxis);
 
   ObjectCreate("Market_Price_Label2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Market_Price_Label2", Market_Price2, FontSize, FontType, FontColor);
   ObjectSet("Market_Price_Label2", OBJPROP_CORNER, WhatCorner);
   ObjectSet("Market_Price_Label2", OBJPROP_XDISTANCE, xAxis+(StringLen(Market_Price)-1)*FontSize);
   ObjectSet("Market_Price_Label2", OBJPROP_YDISTANCE, yAxis);   
   
   
     return(0);
     
  }

//+------------------------------------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+
string rtadjust(string rString,int ra)
  {

   string FILLED;

   FILLED="                           "+rString;

   int sl=StringLen(FILLED);

   rString=StringSubstr(FILLED,sl-ra+1,ra);

   return(rString);
  } 

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+
  
