//+------------------------------------------------------------------+ 
//|   TRO_HL_TRADE                                                   | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 

#property indicator_chart_window

extern bool   Sound_Alert   = false ;
extern bool   Show_Comment  = false ;


extern int    myPeriod      = 0 ;  
extern int    myBars        = 5 ;  

extern int       MAPeriod   = 0;

extern int       MAType     = 1;
extern int       MAPrice    = PRICE_CLOSE ;

extern int    Line_Style    = STYLE_SOLID ;
extern int    Line_Width    = 1 ;

extern color  Line_Color_Hi = Lime ;
extern color  Line_Color_Lo = Red ;

string lbl[15], lbl2[15];
int n, j, i ;

string symbol, tChartPeriod, ShortName ;  

int    digits, period, win ; 

double point ;
 
double close, high, low, cVal = 0, pVal = 0, cV = 0, pV = 0, cMA ; 
 
int    HH, HL, LH, LL ; 
   
bool   CLaboveMA, CLbelowMA  ;   
      
//+------------------------------------------------------------------+

int init()
{
   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }  

   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   ShortName    =  "trohltrade"+symbol+period+myBars  ;
   
   ObDeleteObjectsByPrefix(ShortName);  
   
   Comment("") ;
   
   return(0);
 }
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int ll = StringLen(Prefix);
   int ii = 0; 
   while(ii < ObjectsTotal())
     {
       string ObjName = ObjectName(ii);
       if(StringSubstr(ObjName, 0, ll) != Prefix) 
         { 
           ii++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  } 
      
//+------------------------------------------------------------------+
int deinit()
{
 
   ObDeleteObjectsByPrefix("trohltrade");  
   
 Comment("") ;
return(0);
}
  
//+------------------------------------------------------------------+
int start()
{

n       = 10;
j       = 0 ;
                        
if( MAPeriod > 0 ) 
{ 
   close     = iClose(symbol, period, 0);      
   cMA       = iMA(symbol,period,MAPeriod,0,MAType,MAPrice,0); 
   CLaboveMA = close > cMA ;
   CLbelowMA = close < cMA ;
}
else
{
   CLaboveMA = true ; 
   CLbelowMA = true ;  
}


DoLo( symbol, period )  ; 

j       = j + 1 ;
if(HL > 2 && CLbelowMA )
{
   lbl[j]  = ShortName+j;
   low     = iLow(symbol, period, 1); 
}

if(low > 0 ) { drawLine(low ,lbl[j], Line_Color_Lo , Line_Style ) ; }


DoHi( symbol, period )  ; 

j       = j + 1 ;
if(LH > 2 && CLaboveMA )
{
   lbl[j]  = ShortName+j;
   high = iHigh(symbol, period, 1); 
}

if(high > 0 ) {   drawLine(high ,lbl[j], Line_Color_Hi , Line_Style ) ; }

if(Show_Comment) 
{
   Comment(
   
   "HL " , DoubleToStr(HL,0) , "\n" ,  
   "LH " , DoubleToStr(LH,0) , "\n" ,   
   "HH " , DoubleToStr(HH,0) , "\n" ,  
   "LL " , DoubleToStr(LL,0) , "\n" ,   
   "High " , DoubleToStr(high,digits) , "\n" ,  
   "Low " , DoubleToStr(low,digits) , "\n" ,   
   "") ;
}



if( Sound_Alert)
{
   if( Ask == high ){ Alert(symbol,"  ", tChartPeriod, " High Break "+ DoubleToStr( high ,digits)); }
   if( Bid == low ) { Alert(symbol,"  ", tChartPeriod, " Low Break "+ DoubleToStr( low ,digits)); }
}

return(0);
}
 

//+------------------------------------------------------------------+
 
void drawLine(double lvl,string name, color Col,int type)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            

            ObjectSet(name, OBJPROP_STYLE, type);

            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,Line_Width);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            ObjectSet(name, OBJPROP_STYLE, type);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,Line_Width);
          
         }
 
}
 
//+------------------------------------------------------------------+

void DoHi( string myPair, int yPeriod )  
{
 
HH = 0 ;
LH = 0 ;

for( i=myBars; i>0; i--)
{
   cV = iHigh(myPair, yPeriod, i);                                  
   pV = iHigh(myPair, yPeriod, i+1);    
    
   if( cV > pV ) { HH = HH + 1 ; LH = 0 ;} 
   else 
   if( cV < pV ) { LH = LH + 1 ; HH = 0 ;}
   else  
      { HH = 0 ; LH = 0 ; }

}

   if( HH > 0 ) { cVal = HH; } 
   else 
   if( LH > 0 ) { cVal = LH; }
   else  
      { cVal = 0; }  
  
                                    
} //    
//+------------------------------------------------------------------+

void DoLo( string myPair, int yPeriod )  
{
HL = 0 ;
LL = 0 ;

for( i=myBars; i>0; i--)
{
   cV = iLow(myPair, yPeriod, i);                                  
   pV = iLow(myPair, yPeriod, i+1);    
    
   if( cV > pV ) { HL = HL + 1 ; LL = 0 ;} 
   else 
   if( cV < pV ) { LL = LL + 1 ; HL = 0 ;}
   else  
      { HL = 0 ; LL = 0 ; }

}

   if( HL > 0 ) { cVal = HL; } 
   else 
   if( LL > 0 ) { cVal = LL; }
   else  
      { cVal = 0; }  
                                    
} //  
 

//+------------------------------------------------------------------+
/*
Comment(
  
"HL " , DoubleToStr(HL,0) , "\n" ,  
"LH " , DoubleToStr(LH,0) , "\n" ,   
"HH " , DoubleToStr(HH,0) , "\n" ,  
"LL " , DoubleToStr(LL,0) , "\n" ,   

"") ;

*/