//+------------------------------------------------------------------+
//|   TRO_IND2                                                       |
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpldone@gmail.com                                         |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpldone.com/" 

#property indicator_chart_window
#property indicator_buffers 5

#property indicator_color1 Turquoise   
#property indicator_color2 Navy         
#property indicator_color3 Gold      
#property indicator_color4 MediumVioletRed    
#property indicator_color5 Magenta   

 
//---- parameters
extern int       MAPeriod         = 5;
extern int       MAType           = 1;

extern int BarWidth = 0;

extern color BarColorUp   = Turquoise;
extern color BarColorDown = Magenta;
extern color BarColorUn   = DimGray;
extern color TextColor    = White;

extern int MaxBars=500;
extern int myWingding = 110;// 112

double Gap = 1; // Gap between the lines of bars
//---- buffers

double buf1_up[];
double buf1_down[];
double buf1_un[];


//---- variables

int    MAMode;
string strMAType;
double MA_Cur, MA_Prev,  price;

string tTrade = "" ;   
color tColor    = White;
string tObjName01   ;
int      corner;
int      window; 
string   shortName ;
int      win ;  


int    digits, period  ; 
string symbol, tChartPeriod ;  
double point;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;
   
   shortName  = "Ind2("+MAPeriod+")" ;
   tObjName01 = shortName +  "0" ;

   IndicatorShortName(shortName);  

//---- indicators
   SetIndexStyle(0,DRAW_ARROW,0,BarWidth,BarColorUp);
   SetIndexArrow(0,myWingding);
   SetIndexBuffer(0,buf1_up);

   
   SetIndexStyle(1,DRAW_ARROW,0,BarWidth,BarColorDown);
   SetIndexArrow(1,myWingding);
   SetIndexBuffer(1,buf1_down);

   
   SetIndexStyle(2,DRAW_ARROW,0,BarWidth,BarColorUn);
   SetIndexArrow(2,myWingding);
   SetIndexBuffer(2,buf1_un);
   
switch (MAType)
   {
      case 1: strMAType="EMA"; MAMode=MODE_EMA; break;
      case 2: strMAType="SMMA"; MAMode=MODE_SMMA; break;
      case 3: strMAType="LWMA"; MAMode=MODE_LWMA; break;
      case 4: strMAType="LSMA"; break;
      default: strMAType="SMA"; MAMode=MODE_SMA; break;
   }

      deinit();
//----
   return(0);
  }
 
//+------------------------------------------------------------------+
int deinit()
  {
   TRO();
   return(0);
  }
 
//+------------------------------------------------------------------+


int start()
  {
   
   int counted_bars=IndicatorCounted();
   //---- check for possible errors
   if(counted_bars<0) return(-1);
   //---- the last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   int i;
 
for(i=0;i<limit;i++)
{ 

   buf1_un[i] = EMPTY_VALUE;
    
   price = iClose(symbol,period,i);
     
   MA_Cur  = iMA(symbol,period,MAPeriod,0,MAMode,PRICE_CLOSE,i);
   MA_Prev = iMA(symbol,period,MAPeriod,0,MAMode,PRICE_CLOSE,i+1);
   
    
   if (MA_Cur > MA_Prev && price > MA_Cur) { buf1_up[i]   = MA_Cur;  buf1_down[i] = EMPTY_VALUE; } else
   if (MA_Cur < MA_Prev && price < MA_Cur) { buf1_down[i] = MA_Cur;  buf1_up[i]   = EMPTY_VALUE; } else 
                                           { buf1_un[i] = MA_Cur; }
                                             
} // for 

return(0);
}
 

//+------------------------------------------------------------------+

 
string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
} 
  

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string TRO_OBJ    = "TROTAG"  ;  
   ObjectCreate(TRO_OBJ, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(TRO_OBJ, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(TRO_OBJ, OBJPROP_CORNER, 3);
   ObjectSet(TRO_OBJ, OBJPROP_XDISTANCE, 5 );
   ObjectSet(TRO_OBJ, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+
  


