//+------------------------------------------------------------------+ 
//|   TRO_Linear Regression                                          | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//+------------------------------------------------------------------+
//|                                            Linear Regression.mq4 |
//|                Copyright  2006, tageiger, aka fxid10t@yahoo.com |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//#property copyright "Copyright  2006, tageiger, aka fxid10t@yahoo.com"
//#property link      "http://www.metaquotes.net"


#property indicator_chart_window 

extern int     myChartY       = 1 ;

extern string  myFont         = "Courier" ; // "Verdana"
extern int     myFontSize     = 12 ; //9
extern bool    SHOW_gauge     = true ;
extern bool    SHOW_PriceBox  = false ;
extern int     myBoxWidth     = 3;

extern int     period         =  0;

/*default 0 means the channel will use the open time from "x" bars back on which ever time period 
the indicator is attached to.  one can change to 1,5,15,30,60...etc to "lock" the start time to a specific 
period, and then view the "locked" channels on a different time period...*/

extern int     myShift=0; // if 1 or more static lines

extern int     line_width=2;
extern int     LR_length=120;   // bars back regression begins
extern color   LR_c=Orange;
extern double  std_channel_1=3.0;        // 1st channel
extern color   c_1=Gray;
extern double  std_channel_2=0;        // 2nd channel
extern color   c_2=Gray;
extern double  std_channel_3=0;        // 3nd channel
extern color   c_3=Gray;

extern color myColorH = LightSalmon ;
extern color myColor1 = DodgerBlue ;
extern color myColor2 = DodgerBlue ;
extern color myColor3 = DodgerBlue ;

double ULR1 ,LR_price_2  ;
double LLR1   ;

double ULR2   ;
double LLR2   ;

double ULR3   ;
double LLR3   ;
string tULR1 = "ULR1" ;
string tLLR1 = "LLR1" ;
string tULR2 = "ULR2" ;
string tLLR2 = "LLR2" ;
string tULR3 = "ULR3" ;
string tLLR3 = "LLR3" ;

//+------------------------------------------------------------------+

int    digits, win ; 

double point, close ;  
double X01,X02,X03,X04,X05 ;
double X06 ;   
double X07 ;
double X08, X09, X10; 

string symbol, tChartPeriod ;  
string dHead01, dHead02;
string dLabel01, dValue01;
string dLabel02, dValue02;
string dLabel03, dValue03;
string dLabel04, dValue04;
string dLabel05, dValue05;
string dLabel06, dValue06;
string dLabel07, dValue07;
string dLabel08, dValue08;
string dLabel09, dValue09;
string dLabel10, dValue10;
string dLabel11, dValue11;

//+------------------------------------------------------------------+
int init(){

 

   if(period == 0) { period = Period() ; }    
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   win          = 0 ;
   
 dHead01="llrh01"+ tChartPeriod ;  dHead02="llr202"+ tChartPeriod ;     
    
 dLabel01="llr01"+ tChartPeriod ;  dValue01="llrv01"+ tChartPeriod ; 
 dLabel02="llr02"+ tChartPeriod ;  dValue02="llrv02"+ tChartPeriod ; 
 dLabel03="llr03"+ tChartPeriod ;  dValue03="llrv03"+ tChartPeriod ; 
 dLabel04="llr04"+ tChartPeriod ;  dValue04="llrv04"+ tChartPeriod ; 
 dLabel05="llr05"+ tChartPeriod ;  dValue05="llrv05"+ tChartPeriod ; 
 dLabel06="llr06"+ tChartPeriod ;  dValue06="llrv06"+ tChartPeriod ; 
 dLabel07="llr07"+ tChartPeriod ;  dValue07="llrv07"+ tChartPeriod ; 
 dLabel08="llr08"+ tChartPeriod ;  dValue08="llrv08"+ tChartPeriod ; 
 dLabel09="llr09"+ tChartPeriod ;  dValue09="llrv09"+ tChartPeriod ; 
 dLabel10="llr10"+ tChartPeriod ;  dValue10="llrv10"+ tChartPeriod ; 
 dLabel11="llr11"+ tChartPeriod ;  dValue11="llrv11"+ tChartPeriod ;    

deinit() ;
   
return(0);
}


//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
//+------------------------------------------------------------------+
int deinit()
  {
   ObDeleteObjectsByPrefix("llr");          
   ObDeleteObjectsByPrefix(period);  
   TRO() ;
   return(0);
  }
//+------------------------------------------------------------------+
int start(){//refresh chart
ObjectDelete(period+"m "+LR_length+" TL");
ObjectDelete(period+"m "+LR_length+" +"+std_channel_1+"d"); ObjectDelete(period+"m "+LR_length+" -"+std_channel_1+"d");
ObjectDelete(period+"m "+LR_length+" +"+std_channel_2+"d"); ObjectDelete(period+"m "+LR_length+" -"+std_channel_2+"d");
ObjectDelete(period+"m "+LR_length+" +"+std_channel_3+"d"); ObjectDelete(period+"m "+LR_length+" -"+std_channel_3+"d");
//linear regression calculation

int start_bar=LR_length, end_bar=0 + myShift;

   int n=start_bar-end_bar+1;
//---- calculate price values
   double value=iClose(Symbol(),period,end_bar);
   double a,b,c;
   double sumy=value;
   double sumx=0.0;
   double sumxy=0.0;
   double sumx2=0.0;
   for(int i=1; i<n; i++)
     {
      value=iClose(Symbol(),period,end_bar+i);
      sumy+=value;
      sumxy+=value*i;
      sumx+=i;
      sumx2+=i*i;
     }
   c=sumx2*n-sumx*sumx;
   if(c==0.0) return(0);
   b=(sumxy*n-sumx*sumy)/c;
   a=(sumy-sumx*b)/n;
          LR_price_2=a;
   double LR_price_1=a+b*n;

//---- maximal deviation calculation (not used)
   double max_dev=0;
   double deviation=0;
   double dvalue=a;
   for(i=myShift; i<n; i++)
     {
      value=iClose(Symbol(),period,end_bar+i);
      dvalue+=b;
      deviation=MathAbs(value-dvalue);
      if(max_dev<=deviation) max_dev=deviation;
     }
//Linear regression trendline
   ObjectCreate(period+"m "+LR_length+" TL",OBJ_TREND,0,iTime(Symbol(),period,start_bar),LR_price_1,Time[end_bar],LR_price_2);
   ObjectSet(period+"m "+LR_length+" TL",OBJPROP_COLOR,LR_c);
   ObjectSet(period+"m "+LR_length+" TL",OBJPROP_WIDTH,line_width);
   ObjectSet(period+"m "+LR_length+" TL",OBJPROP_RAY,false);     
//...standard deviation...
   double x=0,x_sum=0,x_avg=0,x_sum_squared=0,std_dev=0;
   for(i=0; i<start_bar; i++)    {
      x=MathAbs(iClose(Symbol(),period,i)-ObjectGetValueByShift(period+"m "+LR_length+" TL",i));
      x_sum+=x;
      if(i>0)  {
         x_avg=(x_avg+x)/i;
         x_sum_squared+=(x-x_avg)*(x-x_avg);
         std_dev=MathSqrt(x_sum_squared/(start_bar-1));  }  }
   //Print("LR_price_1 ",LR_price_1,"  LR_price_2 ",LR_price_2," std_dev ",std_dev);
//...standard deviation channels...

ULR1 = LR_price_2+std_dev*std_channel_1 ;
LLR1 = LR_price_2-std_dev*std_channel_1 ;

ULR2 = LR_price_2+std_dev*std_channel_2 ;
LLR2 = LR_price_2-std_dev*std_channel_2 ;

ULR3 = LR_price_2+std_dev*std_channel_3 ;
LLR3 = LR_price_2-std_dev*std_channel_3 ;

   ObjectCreate(period+"m "+LR_length+" +"+std_channel_1+"d",OBJ_TREND,0,iTime(Symbol(),period,start_bar),LR_price_1+std_dev*std_channel_1,
                                        Time[end_bar],LR_price_2+std_dev*std_channel_1);
   ObjectSet(period+"m "+LR_length+" +"+std_channel_1+"d",OBJPROP_COLOR,c_1);
   ObjectSet(period+"m "+LR_length+" +"+std_channel_1+"d",OBJPROP_WIDTH,line_width);
   ObjectSet(period+"m "+LR_length+" +"+std_channel_1+"d",OBJPROP_RAY,false);
   
   ObjectCreate(period+"m "+LR_length+" -"+std_channel_1+"d",OBJ_TREND,0,iTime(Symbol(),period,start_bar),LR_price_1-std_dev*std_channel_1,
                                             Time[end_bar],LR_price_2-std_dev*std_channel_1);
   ObjectSet(period+"m "+LR_length+" -"+std_channel_1+"d",OBJPROP_COLOR,c_1);
   ObjectSet(period+"m "+LR_length+" -"+std_channel_1+"d",OBJPROP_WIDTH,line_width);
   ObjectSet(period+"m "+LR_length+" -"+std_channel_1+"d",OBJPROP_RAY,false);

   ObjectCreate(period+"m "+LR_length+" +"+std_channel_2+"d",OBJ_TREND,0,iTime(Symbol(),period,start_bar),LR_price_1+std_dev*std_channel_2,
                                             Time[end_bar],LR_price_2+std_dev*std_channel_2);
   ObjectSet(period+"m "+LR_length+" +"+std_channel_2+"d",OBJPROP_COLOR,c_2);
   ObjectSet(period+"m "+LR_length+" +"+std_channel_2+"d",OBJPROP_WIDTH,line_width);
   ObjectSet(period+"m "+LR_length+" +"+std_channel_2+"d",OBJPROP_RAY,false);
   
   ObjectCreate(period+"m "+LR_length+" -"+std_channel_2+"d",OBJ_TREND,0,iTime(Symbol(),period,start_bar),LR_price_1-std_dev*std_channel_2,
                                             Time[end_bar],LR_price_2-std_dev*std_channel_2);
   ObjectSet(period+"m "+LR_length+" -"+std_channel_2+"d",OBJPROP_COLOR,c_2);
   ObjectSet(period+"m "+LR_length+" -"+std_channel_2+"d",OBJPROP_WIDTH,line_width);
   ObjectSet(period+"m "+LR_length+" -"+std_channel_2+"d",OBJPROP_RAY,false);

   ObjectCreate(period+"m "+LR_length+" +"+std_channel_3+"d",OBJ_TREND,0,iTime(Symbol(),period,start_bar),LR_price_1+std_dev*std_channel_3,
                                             Time[end_bar],LR_price_2+std_dev*std_channel_3);
   ObjectSet(period+"m "+LR_length+" +"+std_channel_3+"d",OBJPROP_COLOR,c_3);
   ObjectSet(period+"m "+LR_length+" +"+std_channel_3+"d",OBJPROP_WIDTH,line_width);
   ObjectSet(period+"m "+LR_length+" +"+std_channel_3+"d",OBJPROP_RAY,false);
   
   ObjectCreate(period+"m "+LR_length+" -"+std_channel_3+"d",OBJ_TREND,0,iTime(Symbol(),period,start_bar),LR_price_1-std_dev*std_channel_3,
                                             Time[end_bar],LR_price_2-std_dev*std_channel_3);
   ObjectSet(period+"m "+LR_length+" -"+std_channel_3+"d",OBJPROP_COLOR,c_3);
   ObjectSet(period+"m "+LR_length+" -"+std_channel_3+"d",OBJPROP_WIDTH,line_width);
   ObjectSet(period+"m "+LR_length+" -"+std_channel_3+"d",OBJPROP_RAY,false);
     

if( SHOW_gauge ) { DoShowGauge() ; }
if(SHOW_PriceBox) { DoPriceBox() ; }
     
   
                
return(0);
}

//+------------------------------------------------------------------+ 

void DoShowGauge()
{

X01  = ULR1 ;
X02  = LR_price_2 ;
X03  = LLR1 ;
X04  = ULR2 ;
X05  = LR_price_2 ;
X06  = LLR2 ;
X07  = ULR3  ;
X08  = LR_price_2 ;
X09  = LLR3 ;
X10  = 0 ;

string StrH   = " LR[" + LR_length + "] Gauge" ;
string StrX01 = DoubleToStr(std_channel_1,0) + " Top   " ; 
string StrX02 = DoubleToStr(std_channel_1,0) + " Mid   " ; 
string StrX03 = DoubleToStr(std_channel_1,0) + " Bot   " ; 
string StrX04 = DoubleToStr(std_channel_2,0) + " Top   " ;  
string StrX05 = DoubleToStr(std_channel_2,0) + " Mid   " ; 
string StrX06 = DoubleToStr(std_channel_2,0) + " Bot   " ;
string StrX07 = DoubleToStr(std_channel_3,0) + " Top   " ;
string StrX08 = DoubleToStr(std_channel_3,0) + " Mid   " ;  
string StrX09 = DoubleToStr(std_channel_3,0) + " Bot   " ;  
string StrX10 = " " ;  
  
color color_X01=c_1;
color color_X02=LR_c;
color color_X03=c_1;  

color color_X04=c_2;
color color_X05=LR_c;
color color_X06=c_2;
color color_X07=c_3;  
color color_X08=LR_c;  
color color_X09=c_3; 
/*  
color color_X10=myColor10; 

*/


close = iClose(NULL,period,0) ;    

if( close  > ULR1        ) { color_X01 = Lime ; } else { color_X01 = Red ; } 
if( close  > LR_price_2  ) { color_X02 = Lime ; } else { color_X02 = Red ; } 
if( close  > LLR1        ) { color_X03 = Lime ; } else { color_X03 = Red ; }   

if( close  > ULR2        ) { color_X04 = Lime ; } else { color_X04 = Red ; } 
if( close  > LR_price_2  ) { color_X05 = Lime ; } else { color_X05 = Red ; } 
if( close  > LLR2        ) { color_X06 = Lime ; } else { color_X06 = Red ; }  

if( close  > ULR3        ) { color_X07 = Lime ; } else { color_X07 = Red ; } 
if( close  > LR_price_2  ) { color_X08 = Lime ; } else { color_X08 = Red ; } 
if( close  > LLR3        ) { color_X09 = Lime ; } else { color_X09 = Red ; }  

//---- Set Pivots labels

   int WindowToUse;
   int Corner_line, Xdist_line;
   int Corner_text, Corner_vSRFP, Xdist_text, Xdist_vSRFP;
   int Ydist_line5;
   int Corner_pivots, Xdist_pivots, Ydist_pivots;
   int Ydist_X01, Ydist_X02, Ydist_X03, Ydist_X04, Ydist_X05, Ydist_X06, Ydist_X07, Ydist_X08, Ydist_X09, Ydist_X10 ;
  
   int YdistInc ;
   
    WindowToUse =  0;
    Corner_line = 1;
    Corner_text = 1; Corner_vSRFP = 1;
    Xdist_line = 21; Xdist_text = 93; Xdist_vSRFP = 23;
    Corner_pivots = 1; Xdist_pivots = 21; 
    
    Ydist_pivots = myChartY;  
    Ydist_line5 = Ydist_pivots + 11; YdistInc = 15 ;
    
    Ydist_X01 = Ydist_pivots + 25; 
    Ydist_X02 = Ydist_X01 + YdistInc; 
    Ydist_X03 = Ydist_X01 + YdistInc*2; 
    Ydist_X04 = Ydist_X01 + YdistInc*3; 
    Ydist_X05 = Ydist_X01 + YdistInc*4;
    Ydist_X06 = Ydist_X01 + YdistInc*5;    
    Ydist_X07 = Ydist_X01 + YdistInc*6;
    Ydist_X08 = Ydist_X01 + YdistInc*7;    
    Ydist_X09 = Ydist_X01 + YdistInc*8;    
    Ydist_X10 = Ydist_X01 + YdistInc*9;    

//+------------------------------------------------------------------+ 
   ObjectCreate(dHead01, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dHead01,tChartPeriod + StrH,myFontSize, myFont, myColorH);
   ObjectSet(dHead01, OBJPROP_CORNER, Corner_pivots);
   ObjectSet(dHead01, OBJPROP_XDISTANCE, Xdist_pivots);
   ObjectSet(dHead01, OBJPROP_YDISTANCE, Ydist_pivots);
   
   ObjectCreate(dHead02, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dHead02,"-----------------",myFontSize, myFont, myColorH);
   ObjectSet(dHead02, OBJPROP_CORNER, Corner_line);
   ObjectSet(dHead02, OBJPROP_XDISTANCE, Xdist_line);
   ObjectSet(dHead02, OBJPROP_YDISTANCE, Ydist_line5);

//+------------------------------------------------------------------+    

if(std_channel_1 > 0) 
{
   ObjectCreate(dLabel01, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel01,StrX01,myFontSize, myFont, myColor1 );
   ObjectSet(dLabel01, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel01, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel01, OBJPROP_YDISTANCE, Ydist_X01);
   
   ObjectCreate(dValue01, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue01," "+DoubleToStr(X01,digits),myFontSize, myFont, color_X01);
   ObjectSet(dValue01, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue01, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue01, OBJPROP_YDISTANCE, Ydist_X01);

//+------------------------------------------------------------------+     
   ObjectCreate(dLabel02, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel02,StrX02,myFontSize, myFont, myColor1 );
   ObjectSet(dLabel02, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel02, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel02, OBJPROP_YDISTANCE, Ydist_X02);
   
   ObjectCreate(dValue02, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue02," "+DoubleToStr(X02,digits),myFontSize, myFont, color_X02);
   ObjectSet(dValue02, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue02, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue02, OBJPROP_YDISTANCE, Ydist_X02);

//+------------------------------------------------------------------+ 
   ObjectCreate(dLabel03, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel03,StrX03,myFontSize, myFont, myColor1 );
   ObjectSet(dLabel03, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel03, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel03, OBJPROP_YDISTANCE, Ydist_X03);
   
   ObjectCreate(dValue03, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue03," "+DoubleToStr(X03,digits),myFontSize, myFont, color_X03);
   ObjectSet(dValue03, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue03, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue03, OBJPROP_YDISTANCE, Ydist_X03);
}
//+------------------------------------------------------------------+ 
if(std_channel_2 > 0) 
{

   ObjectCreate(dLabel04, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel04,StrX04,myFontSize, myFont, myColor2 );
   ObjectSet(dLabel04, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel04, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel04, OBJPROP_YDISTANCE, Ydist_X04);
   
   ObjectCreate(dValue04, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue04," "+DoubleToStr(X04,digits),myFontSize, myFont, color_X04);
   ObjectSet(dValue04, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue04, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue04, OBJPROP_YDISTANCE, Ydist_X04);  

//+------------------------------------------------------------------+    
   ObjectCreate(dLabel05, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel05,StrX05,myFontSize, myFont, myColor2 );
   ObjectSet(dLabel05, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel05, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel05, OBJPROP_YDISTANCE, Ydist_X05);
   
   ObjectCreate(dValue05, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue05," "+DoubleToStr(X05,digits),myFontSize, myFont, color_X05);
   ObjectSet(dValue05, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue05, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue05, OBJPROP_YDISTANCE, Ydist_X05);

//+------------------------------------------------------------------+     
   ObjectCreate(dLabel06, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel06,StrX06,myFontSize, myFont, myColor2 );
   ObjectSet(dLabel06, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel06, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel06, OBJPROP_YDISTANCE, Ydist_X06);
   
   ObjectCreate(dValue06, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue06," "+DoubleToStr(X06,digits),myFontSize, myFont, color_X06);
   ObjectSet(dValue06, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue06, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue06, OBJPROP_YDISTANCE, Ydist_X06);
}
if(std_channel_3 > 0) 
{
   ObjectCreate(dLabel07, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel07,StrX07,myFontSize, myFont, myColor3 );
   ObjectSet(dLabel07, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel07, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel07, OBJPROP_YDISTANCE, Ydist_X07);
   
   ObjectCreate(dValue07, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue07," "+DoubleToStr(X07,digits),myFontSize, myFont, color_X07);
   ObjectSet(dValue07, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue07, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue07, OBJPROP_YDISTANCE, Ydist_X07);

   ObjectCreate(dLabel08, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel08,StrX08,myFontSize, myFont, myColor3 );
   ObjectSet(dLabel08, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel08, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel08, OBJPROP_YDISTANCE, Ydist_X08);
   
   ObjectCreate(dValue08, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue08," "+DoubleToStr(X08,digits),myFontSize, myFont, color_X08);
   ObjectSet(dValue08, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue08, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue08, OBJPROP_YDISTANCE, Ydist_X08);  
  
   ObjectCreate(dLabel09, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel09,StrX09,myFontSize, myFont, myColor3 );
   ObjectSet(dLabel09, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel09, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel09, OBJPROP_YDISTANCE, Ydist_X09);
   
   ObjectCreate(dValue09, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue09," "+DoubleToStr(X09,digits),myFontSize, myFont, color_X09);
   ObjectSet(dValue09, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue09, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue09, OBJPROP_YDISTANCE, Ydist_X09);  

}
/*
   
   ObjectCreate(dLabel10, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel10,StrX10,myFontSize, myFont, myColor10 );
   ObjectSet(dLabel10, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel10, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel10, OBJPROP_YDISTANCE, Ydist_X10);
   
   ObjectCreate(dValue10, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue10," "+DoubleToStr(X10,digits),myFontSize, myFont, color_X10);
   ObjectSet(dValue10, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue10, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue10, OBJPROP_YDISTANCE, Ydist_X10);  
*/  
}

void DoPriceBox()
{
if( std_channel_1 != 0 ) 
{
      
    if (ObjectFind(tULR1) != 0)
      {
          ObjectCreate(tULR1,OBJ_ARROW,0,Time[0],ULR1);
          ObjectSet(tULR1,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tULR1,OBJPROP_COLOR,c_1);  
          ObjectSet(tULR1,OBJPROP_WIDTH,myBoxWidth);
      } 
      else
      {
         ObjectMove(tULR1,0,Time[0],ULR1);
      }
 
  
    if (ObjectFind(tLLR1) != 0)
      {
          ObjectCreate(tLLR1,OBJ_ARROW,0,Time[0],LLR1);
          ObjectSet(tLLR1,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tLLR1,OBJPROP_COLOR,c_1);
          ObjectSet(tLLR1,OBJPROP_WIDTH,myBoxWidth);   
      } 
      else
      {
         ObjectMove(tLLR1,0,Time[0],LLR1);
      }
} // if( std_channel_1 != 0 ) 



if( std_channel_2 != 0 ) 
{

    
    if (ObjectFind(tULR2) != 0)
      {
          ObjectCreate(tULR2,OBJ_ARROW,0,Time[0],ULR2);
          ObjectSet(tULR2,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tULR2,OBJPROP_COLOR,c_2); 
          ObjectSet(tULR2,OBJPROP_WIDTH,myBoxWidth); 
      } 
      else
      {
         ObjectMove(tULR2,0,Time[0],ULR2);
      }
 

    
    if (ObjectFind(tLLR2) != 0)
      {
          ObjectCreate(tLLR2,OBJ_ARROW,0,Time[0],LLR2);
          ObjectSet(tLLR2,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tLLR2,OBJPROP_COLOR,c_2);  
          ObjectSet(tLLR2,OBJPROP_WIDTH,myBoxWidth);
      } 
      else
      {
         ObjectMove(tLLR2,0,Time[0],LLR2);
      }
} // if( std_channel_2 != 0 ) 


if( std_channel_3 != 0 ) 
{


    if (ObjectFind(tULR3) != 0)
      {
          ObjectCreate(tULR3,OBJ_ARROW,0,Time[0],ULR3);
          ObjectSet(tULR3,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tULR3,OBJPROP_COLOR,c_3); 
          ObjectSet(tULR3,OBJPROP_WIDTH,myBoxWidth); 
      } 
      else
      {
         ObjectMove(tULR3,0,Time[0],ULR3);
      }
 

    
    if (ObjectFind(tLLR3) != 0)
      {
          ObjectCreate(tLLR3,OBJ_ARROW,0,Time[0],LLR3);
          ObjectSet(tLLR3,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tLLR3,OBJPROP_COLOR,c_3);
          ObjectSet(tLLR3,OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tLLR3,0,Time[0],LLR3);
      }
} // if( std_channel_3 != 0 ) 
    
    if (ObjectFind("M_LR") != 0)
      {
          ObjectCreate("M_LR",OBJ_ARROW,0,Time[0],LR_price_2);
          ObjectSet("M_LR",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet("M_LR",OBJPROP_COLOR,LR_c);
          ObjectSet("M_LR",OBJPROP_WIDTH,myBoxWidth);   
      } 
      else
      {
         ObjectMove("M_LR",0,Time[0],LR_price_2);
      } 
}

      
//+------------------------------------------------------------------+ 

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+