//+------------------------------------------------------------------+
 

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 8
#property indicator_color1 Lime
#property indicator_color2 OrangeRed
#property indicator_minimum 0
#property indicator_maximum 4

extern bool   MOMO_Sound_Alert    = true ;
extern bool   MOMO_Comment    = false ;
  


extern color MOMO_BarColorUp   = Lime;
extern color MOMO_BarColorDown = OrangeRed;
//extern color TextColor    = White;

int MOMO_BarWidth = 0;
int myWingding = 110;// 112

double buf1_up[];
double buf1_down[];
 

//---- indicator parameters
  int FastEMA=2;
  int SlowEMA=3;
  int SignalSMA=9;
//---- indicator buffers
double     MBuffer[];
double     SBuffer[];
double     HHBuffer[];
double     LHBuffer[];
double     HLBuffer[];
double     LLBuffer[];


string symbol, tChartPeriod,  tShortName ;  
int    digits, period  ; 
datetime Trigger ;

//---- variables

string tTrade = "" ;   
color tColor    = White;
string tObjName01   ;
int      corner;
int      window; 
string   shortName;
int      win ;  

bool sFirst;



int YourAccountNumber, maxi ;


double point, pos = 1, pos1 = 2 , pos2 = 1 ;

 

bool FILLED = false,  GREEN = false;



double    D1_Open, D1_Close, D1_high, D1_low, D1_range, D1_pivot, D1_ClOp    ; 
 
double   RANGE, MALOW, RANGE1, MOMONUM, MACLOSE, MACLOSE1 ;  

//+------------------------------------------------------------------+
int init()
  {
  
  
  
  sFirst = true ;
  

   
   period       =  Period() ;     
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;
   
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }    
   
   
   shortName  = "Momentum Bars " +  Symbol() + " " + tChartPeriod ;
   tObjName01 = shortName +  "0" ;


   IndicatorShortName(shortName);  

//---- indicators
   SetIndexStyle(0,DRAW_ARROW,0,MOMO_BarWidth,MOMO_BarColorUp);
   SetIndexArrow(0,myWingding);
   SetIndexBuffer(0,buf1_up);

   
   SetIndexStyle(1,DRAW_ARROW,0,MOMO_BarWidth,MOMO_BarColorDown);
   SetIndexArrow(1,myWingding);
   SetIndexBuffer(1,buf1_down);
     

   SetIndexStyle(2,DRAW_ARROW,0,MOMO_BarWidth,MOMO_BarColorUp);
   SetIndexArrow(2,myWingding);
   SetIndexBuffer(2,HHBuffer);

   
   SetIndexStyle(3,DRAW_ARROW,0,MOMO_BarWidth,MOMO_BarColorDown);
   SetIndexArrow(3,myWingding);
   SetIndexBuffer(3,LHBuffer);


   SetIndexStyle(4,DRAW_ARROW,0,MOMO_BarWidth,MOMO_BarColorUp);
   SetIndexArrow(4,myWingding);
   SetIndexBuffer(4,HLBuffer);

   
   SetIndexStyle(5,DRAW_ARROW,0,MOMO_BarWidth,MOMO_BarColorDown);
   SetIndexArrow(5,myWingding);
   SetIndexBuffer(5,LLBuffer);   
   IndicatorDigits(0);
   
   
   return(0);
  }
  
//+------------------------------------------------------------------+
int deinit()
  {
 
  Comment("") ;
   return(0);
  }
    
//+------------------------------------------------------------------+
//| Moving Averages                           |
//+------------------------------------------------------------------+
int start()
  {
  
  
  
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   
   if(FILLED) { limit=Bars-counted_bars; }
   else { limit = Bars ; }
   


   for(int i=0; i<limit; i++)
   {
      buf1_down[i]=EMPTY_VALUE;
      buf1_up[i]  =EMPTY_VALUE; 
      HHBuffer[i]  =EMPTY_VALUE;
      LHBuffer[i]  =EMPTY_VALUE; 
      HLBuffer[i]  =EMPTY_VALUE;
      LLBuffer[i]  =EMPTY_VALUE; 
      
               
      RANGE    = Close[i] - Open[i]  ;
      RANGE1   = Close[i+1] - Open[i+1] ;     
      
      GREEN    = Close[i] >= Open[i]  ;
                  
      if( RANGE1 != 0 ) { MOMONUM = MathAbs(RANGE / RANGE1) ; }  else { MOMONUM = 0.0 ; } 
   
 
      if ( MOMONUM > 2.0 && GREEN ) { buf1_up[i] = pos ; }
      else 
      if ( MOMONUM > 2.0 && !GREEN  ) { buf1_down[i]   = pos ; }
          
      
  }

   if( i > 100 ) { FILLED = true ; }

  if (  Trigger != Time[0] && MOMO_Sound_Alert ) // Trigger != Time[0] && 
  {
        if( buf1_up[1]   == pos && buf1_up[2]   != pos ) { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, " Momo Up "+ DoubleToStr(Close[0] ,digits)); }
        if( buf1_down[1] == pos && buf1_down[2] != pos ) { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, " Momo Dn "+ DoubleToStr(Close[0] ,digits)); }     
  }

if(MOMO_Comment)
{
D1_Open  = iOpen(symbol,PERIOD_D1,0);  
D1_Close = iClose(symbol,PERIOD_D1,0);  
D1_high  = iHigh(symbol,PERIOD_D1,0);
D1_low   = iLow(symbol,PERIOD_D1,0);
D1_pivot = ( D1_Close + D1_high + D1_low ) / 3.0 ; 
D1_range = ( D1_high - D1_low ) / point ;
D1_ClOp  = ( D1_Close - D1_Open ) / point ;


Comment(

 "\n" , "Daily " ,  
"O=" , DoubleToStr(D1_Open,Digits) , " " ,
"H=" , DoubleToStr(D1_high,Digits) , " " ,
"L=" , DoubleToStr(D1_low,Digits) , " " ,
"C=" , DoubleToStr(D1_Close,Digits) , " " ,
"P=" , DoubleToStr(D1_pivot,Digits) , " " ,
"R=" , DoubleToStr(D1_range,0) , " " ,
"D=" , DoubleToStr(D1_ClOp,0) , " " ,

"") ; 
} // if(MOMO_Comment)


return(0);
}
  
//+------------------------------------------------------------------+
 

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
//+------------------------------------------------------------------+
/*

      RANGE    = High[i] - Low[i]  ;
      RANGE1   = High[i+1] - Low[i+1] ;     
      
      
Comment(

"pair " , symbol , "\n" , 
"MBuffer[0] " , DoubleToStr(MBuffer[0],6) , "\n" ,
"SBuffer[0] " , DoubleToStr(SBuffer[0],6) , "\n" ,

"buf1_up[0] " , DoubleToStr(buf1_up[0],Digits) , "\n" ,
"buf1_up[1] " , DoubleToStr(buf1_up[1],Digits) , "\n" ,
"buf1_up[2] " , DoubleToStr(buf1_up[1],Digits) , "\n" ,
"buf1_down[0] " , DoubleToStr(buf1_down[0],Digits) , "\n" ,
"buf1_down[1] " , DoubleToStr(buf1_down[1],Digits) , "\n" ,
"buf1_down[2] " , DoubleToStr(buf1_down[1],Digits) , "\n" ,
"") ; 

*/