//+------------------------------------------------------------------+
//|         TRO_PIP_DIFF_HIST                                        |
//|                                                                  |
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND CONTRIBUTIONS ACCEPTED                               | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 
#property  indicator_separate_window
#property  indicator_buffers 8
#property  indicator_color1  Lime
#property  indicator_color2  Coral
//#property  indicator_color3  Black //Aqua
#property  indicator_color4  Red
#property  indicator_color7  Green
#property  indicator_color8  Maroon


#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width7 3
#property indicator_width8 3



//---- indicator parameters

extern string myPair1 = "GBPCHF" ;
extern string myPair2 = "CHFJPY" ;

extern int myDiffAvgPeriods = 50; 

extern int x_offset= 0 ; 
extern int y_offset= 0 ; 

  
extern string myFont       = "Arial Bold" ;
extern int    myFontSize   = 15 ;
extern int    xStart       = 0 ;
extern int    xOffSet      = 0 ;


//---- indicator buffers
double     ind_Buffer1[];
double     ind_Buffer2[];
double     ind_buffer3a[];
double     ind_buffer3b[];
double     ind_buffer3c[];
double     ind_buffer3d[];

double     ind_buffer4[];
double     ind_buffer5[];


string   tObjName01 , tObjName02 ;
string   tTrade = "" ;   
string   shortName ;

color    tColor    = White;

int      corner;
int      window; 
int      win ;  
 
double point1, point2, value ; 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

//---- 2 additional buffers are used for counting.
//   IndicatorBuffers(8);
//---- drawing settings

   SetIndexStyle(0,DRAW_HISTOGRAM);
//   SetIndexDrawBegin(0,myDiffAvgPeriods);
//   SetIndexStyle(1,DRAW_LINE);
 
   

SetIndexBuffer(0,ind_buffer4) ;
//SetIndexBuffer(1,ind_buffer5) ; 


      
   shortName = "TRO_PIP_HIST ("+ myDiffAvgPeriods+ ") " + myPair1 + " " + myPair2 + " " + Period();

   IndicatorShortName(shortName);   


   tObjName01 = shortName + "01";
   tObjName02 = shortName + "02";
      
   point1 = MarketInfo(myPair1,MODE_POINT);
   point2 = MarketInfo(myPair2,MODE_POINT); 
     
   return(0);
  }

//+------------------------------------------------------------------+  
int deinit()
  {
   ObjectsDeleteAll(win);   
   return(0);
  }  
  
//+------------------------------------------------------------------+

int start()
  {
  
   win =    WindowFind(shortName);
   
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st additional buffer
   for(int i=0; i<limit; i++)
   { 
      value         = iClose(myPair1,0,i) - iClose(myPair2,0,i) ; 
      ind_buffer4[i]= MathAbs(value) ;
   }
//---- signal line counted in the 2-nd additional buffer

/* 
   for(i=0; i<limit; i++)
      ind_buffer5[i]=iMAOnArray(ind_buffer4,Bars,myDiffAvgPeriods,0,0,i);
 */     

      
//---- main loop



   ObjectCreate(tObjName01, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName01, DoubleToStr(ind_buffer4[0],4) , myFontSize, myFont, indicator_color1 );
   ObjectSet(tObjName01, OBJPROP_CORNER, 1);
   ObjectSet(tObjName01, OBJPROP_XDISTANCE, 10+x_offset); // 
   ObjectSet(tObjName01, OBJPROP_YDISTANCE, 0+y_offset); //  
/*
   ObjectCreate(tObjName02, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName02, DoubleToStr(ind_buffer5[0],4) , myFontSize, myFont, indicator_color2 );
   ObjectSet(tObjName02, OBJPROP_CORNER, 1);
   ObjectSet(tObjName02, OBJPROP_XDISTANCE, 0+x_offset); // 
   ObjectSet(tObjName02, OBJPROP_YDISTANCE, 0+y_offset); //      
*/       
   return(0);
  }
//+------------------------------------------------------------------+

