//+------------------------------------------------------------------+ 
//|   TRO_PLOT                                                       | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 

#property indicator_chart_window

extern bool TURN_OFF    = false ;

extern int    myShift       = 1 ;  
extern int    Line_Style    = STYLE_SOLID ;
extern int    Line_Width    = 2 ;

extern bool Plot_Open  = true ;
extern bool Plot_High  = true ;
extern bool Plot_Low   = true ;
extern bool Plot_Close = false ;
extern bool Plot_Pivot = true ;
extern bool Plot_MidPt = true ;

extern bool Show_Label = true ;
//extern int  ShiftLabel =  4 ; 

extern bool Show_M1  = false ;
extern bool Show_M5  = false ;
extern bool Show_M15 = true ;
extern bool Show_H1  = true ;
extern bool Show_H4  = true ;
extern bool Show_D1  = true ;
extern bool Show_W1  = true ;
extern bool Show_MN1 = true ;


extern color color_M1  = Yellow ;
extern color color_M5  = Orange ;
extern color color_M15 = Red ;
extern color color_H1  = Bisque ; 
extern color color_H4  = Pink ;
extern color color_D1  = Purple ; 
extern color color_W1  = PaleGreen ;
extern color color_MN1 = DodgerBlue ;

string lbl[30], lbl2[30];
int n, j, i , lTime;

string symbol, tChartPeriod, ShortName ;  

int    digits, period, win ; 

double point,  open, high, low, close, diff, mid, range, pClose, pOpen, pHigh, pLow, pMid, pRange, cRange  ;   
 
 

double    HHprice, LLprice, OPprice, CLprice, PVprice, MDprice;
 
      
//+------------------------------------------------------------------+

int init()
{
   period = Period() ;

   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   ShortName    =  "trohl-"  + symbol + myShift ;
   
   deinit();
 
   return(0);
  }
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int ll = StringLen(Prefix);
   int ii = 0; 
   while(ii < ObjectsTotal())
     {
       string ObjName = ObjectName(ii);
       if(StringSubstr(ObjName, 0, ll) != Prefix) 
         { 
           ii++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  } 
      
//+------------------------------------------------------------------+
int deinit()
{
 
   ObDeleteObjectsByPrefix(ShortName); 
   TRO();
   
   return(0);
}
  
//+------------------------------------------------------------------+
int start()
{

   deinit();
   if( TURN_OFF ) {  return(0) ; }
   
   n       = 10;
    
   j       = 0 ;
    
   
   if( Show_M1 )  DoLabel( PERIOD_M1 , color_M1 ) ;
   if( Show_M5 )  DoLabel( PERIOD_M5 , color_M5 ) ;
   if( Show_M15 ) DoLabel( PERIOD_M15 , color_M15 ) ;
   if( Show_H1 )  DoLabel( PERIOD_H1 , color_H1 ) ;
   if( Show_H4 )  DoLabel( PERIOD_H4 , color_H4 ) ;
   if( Show_D1 )  DoLabel( PERIOD_D1 , color_D1 ) ;
   if( Show_W1 )  DoLabel( PERIOD_W1 , color_W1 ) ;
   if( Show_MN1 ) DoLabel( PERIOD_MN1 , color_MN1 ) ;
   
   return(0);
}
 

//+------------------------------------------------------------------+
 
 
void DoLabel( int wPeriod , color wColor)
{

   lTime   = 10 ;
   
   HHprice = iHigh(symbol,wPeriod,myShift);  
   LLprice = iLow(symbol,wPeriod,myShift);  
   OPprice = iOpen(symbol,wPeriod,myShift);  
   CLprice = iClose(symbol,wPeriod,myShift);  
   PVprice = (HHprice + LLprice + CLprice) * 0.3333 ; 
   MDprice = (HHprice + LLprice ) * 0.50 ; 
   
   
   if(Plot_Low)
   { 
   j       = j + 1 ;
   lbl[j]  = ShortName+j+wPeriod;
   drawLine(LLprice ,lbl[j], wColor , Line_Style, TimeFrameToString(wPeriod)+"["+ myShift +"] Low"  ) ;
   lTime   = lTime + 5 ;
   }


   if(Plot_High)
   { 
   j       = j + 1 ;
   lbl[j]  = ShortName+j+wPeriod;
   drawLine(HHprice ,lbl[j], wColor , Line_Style, TimeFrameToString(wPeriod)+"["+ myShift +"] High"  ) ; 
   lTime   = lTime + 5 ;
   }
   
   
   if(Plot_Open)
   { 
   j       = j + 1 ;
   lbl[j]  = ShortName+j+wPeriod;
   drawLine(OPprice ,lbl[j], wColor , Line_Style, TimeFrameToString(wPeriod)+"["+ myShift +"] Open"  ) ;
   lTime   = lTime + 5 ;
   }

   
   if(Plot_Close)
   { 
   j       = j + 1 ;
   lbl[j]  = ShortName+j+wPeriod;
   drawLine(CLprice ,lbl[j], wColor , Line_Style, TimeFrameToString(wPeriod)+"["+ myShift +"] Close"  ) ; 
   }
   
   if(Plot_MidPt)
   { 
   j       = j + 1 ;
   lbl[j]  = ShortName+j+wPeriod;
   drawLine(MDprice ,lbl[j], wColor , Line_Style, TimeFrameToString(wPeriod)+"["+ myShift +"] Midpt"  ) ; 
   }
   
   if(Plot_Pivot)
   { 
   j       = j + 1 ;
   lbl[j]  = ShortName+j+wPeriod;
   drawLine(PVprice ,lbl[j], wColor , Line_Style, TimeFrameToString(wPeriod)+"["+ myShift +"] PVprice"  ) ; 

   }
 
  
}
 

//+------------------------------------------------------------------+
 
void drawLine(double lvl,string name, color Col,int type, string desc )
{
        
      datetime  TimeBar  ;

      TimeBar  = iTime( symbol,PERIOD_MN1, myShift+1 ) ; 

      
        
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],lvl);
            ObjectSet(name, OBJPROP_STYLE, type);
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name, OBJPROP_WIDTH,Line_Width);
            ObjectSet(name, OBJPROP_BACK,true);
            ObjectSet(name,OBJPROP_RAY,false);   
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],lvl);
            ObjectSet(name, OBJPROP_STYLE, type);
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,Line_Width);
            ObjectSet(name, OBJPROP_BACK,true); 
            ObjectSet(name,OBJPROP_RAY,false);            
         }
    
   if(Show_Label)
   { 
   
    //     datetime LabelTime = Time[0]+Period()*60*ShiftLabel   ;
   
   //+------------------------------------------------------------------+
   //Determine the current chart scale (chart scale number should be 0-5) use to place labels to right of price arrow
        
     int Chart_Scale  ,Bar_Width  ; 
        
     Chart_Scale = ChartScaleGet();
     
     //Set bar widths             
           if(Chart_Scale == 0) {Bar_Width = 120;}
     else {if(Chart_Scale == 1) {Bar_Width = 60;}      
     else {if(Chart_Scale == 2) {Bar_Width = 30;}
     else {if(Chart_Scale == 3) {Bar_Width = 15;}
     else {if(Chart_Scale == 4) {Bar_Width = 8;}
     else {Bar_Width = 4;} }}}}
     
     datetime LabelTime = Time[0]+Period()*60*Bar_Width ; // Time[WindowFirstVisibleBar()/2]; // Time[0]+Period()*60*ShiftLabel ;   
       
   
         if(ObjectFind(name+desc) != 0)
         {
            ObjectCreate(name+desc, OBJ_TEXT, 0, LabelTime, lvl);
            ObjectSetText(name+desc, fFill(desc + " " + DoubleToStr(lvl,digits),20), 8, "Terminal", Col);
         }
         else
         {
            ObjectMove(name+desc, 0, LabelTime, lvl);
         } 
   }
    
}


//+--------- TRO MODIFICATION ---------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
   return(FILLED);
}
 
  
//+-------------------------------------------------------------------------------------------+
//| Subroutine:  Get the chart scale number                                                   |
//+-------------------------------------------------------------------------------------------+
int ChartScaleGet()
{
  long result = -1;
  ChartGetInteger(0,CHART_SCALE,0,result);
  return((int)result);
}
 
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string TRO_OBJ    = "TROTAG"  ;  
   ObjectCreate(TRO_OBJ, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(TRO_OBJ, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(TRO_OBJ, OBJPROP_CORNER, 3);
   ObjectSet(TRO_OBJ, OBJPROP_XDISTANCE, 5 );
   ObjectSet(TRO_OBJ, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+
/*

Comment(

"ind_bufferOp[0]" , ind_bufferOp[0] , "\n" ,   
 

"") ; 
*/