//+------------------------------------------------------------------+
//|                                                  Heiken Ashi.mq4 |
//|                      Copyright c 2004, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//| For Heiken Ashi we recommend next chart settings ( press F8 or   |
//| select on menu 'Charts'->'Properties...'):                       |
//|  - On 'Color' Tab select 'Black' for 'Line Graph'                |
//|  - On 'Common' Tab disable 'Chart on Foreground' checkbox and    |
//|    select 'Line Chart' radiobutton                               |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Blue
#property indicator_color5 SteelBlue
#property indicator_color6 SteelBlue 
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 3

//----
extern bool  Show_Wicks = true;
extern bool  Show_Wicks_Mid = true;

extern color color1 = Red;
extern color color2 = Red;
extern color color3 = Blue;
extern color color4 = Blue;
extern color color5 = SteelBlue;
extern color color6 = SteelBlue;
extern int myWingDing  = 119 ; // 171


//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
//----
int ExtCountedBars=0;

double TOP, BOTTOM ;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
  {
//---- indicators

   if(Show_Wicks)
   {
         SetIndexStyle(0,DRAW_HISTOGRAM, 0, 3, color1);
         SetIndexBuffer(0, ExtMapBuffer1);
         SetIndexStyle(1,DRAW_HISTOGRAM, 0, 3, color2);
         SetIndexBuffer(1, ExtMapBuffer2);
         SetIndexStyle(2,DRAW_HISTOGRAM, 0, 3, color3);
         SetIndexBuffer(2, ExtMapBuffer3);
         SetIndexStyle(3,DRAW_HISTOGRAM, 0, 3, color4);
         SetIndexBuffer(3, ExtMapBuffer4);
      //----
         SetIndexDrawBegin(0,10);
         SetIndexDrawBegin(1,10);
         SetIndexDrawBegin(2,10);
         SetIndexDrawBegin(3,10);
      //---- indicator buffers mapping
         SetIndexBuffer(0,ExtMapBuffer1);
         SetIndexBuffer(1,ExtMapBuffer2);
         SetIndexBuffer(2,ExtMapBuffer3);
         SetIndexBuffer(3,ExtMapBuffer4);
      }
   
      if(Show_Wicks_Mid)
      {     
            
         SetIndexBuffer(4, ExtMapBuffer5);
         SetIndexArrow(4, myWingDing); 
         SetIndexStyle(4, DRAW_ARROW, 0, 1, color5 );   
          
         SetIndexBuffer(5, ExtMapBuffer6);
         SetIndexArrow(5, myWingDing); 
         SetIndexStyle(5, DRAW_ARROW, 0, 1, color6 );    
      }   
            
//---- initialization done

    deinit();
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   TRO() ;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double haOpen, haHigh, haLow, haClose;
   if(Bars<=10) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   int pos=Bars-ExtCountedBars-1;
   while(pos>=0)
     {
      haOpen  = Open[pos+1];
      haClose = Close[pos+1];
      haHigh  = High[pos+1];
      haLow   = Low[pos+1];
      TOP     = MathMax(haClose,haOpen);
      BOTTOM  = MathMin(haClose,haOpen);
 
         ExtMapBuffer1[pos] = haHigh;
         ExtMapBuffer2[pos] = TOP;
         ExtMapBuffer3[pos] = BOTTOM;
         ExtMapBuffer4[pos] = haLow;          
         ExtMapBuffer5[pos] = 0.50 * ( haHigh + TOP ) ; 
         ExtMapBuffer6[pos] = 0.50 * ( BOTTOM + haLow ) ;   

 	   pos--;
     }
//----

   WindowRedraw();

   return(0);
  }
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 