//+------------------------------------------------------------------+ 
//|   _TRO_COMPASS_EZ                                                | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpldone@gmail.com                                         |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpldone.com/" 

//---- indicator settings 
#property indicator_chart_window
#property indicator_buffers 0
#property indicator_minimum 0
#property indicator_maximum 1



//---- indicator parameters  
 

extern int win = 0;
extern int price_x_offset= 0 ;//250
extern int price_y_offset= -160 ;//-160


extern color N_color  = Lime;
extern color NE_color = Green;
extern color E_color  = Yellow;
extern color SE_color = Orange;
extern color S_color  = Red;


//---- indicator buffers 


double     MaxRange = 0 ; 
double     MinRange = 0 ; 
double     AvgRange = 0 ; 
double     xRange   = 0 ; 
double     tRange   = 0 ; 

 int   Chart_Period    = PERIOD_H1;


//---- buffers


double zRANGE = 0;

bool  Show_info       = true;
bool  ShowChart       = true; 



string Arrow12 = ""; // 12 oclock
string Arrow2  = "";  // 2 oclock
string Arrow3  = "";  // 3 oclock
string Arrow5  = "";  // 5 oclock
string Arrow6  = "";  // 6 oclock
//+------------------------------------------------------------------+

color fColor( double i)
{
color rColor ;

    if ( i == 5 ) rColor = N_color ; else {
    if ( i == 4 ) rColor = NE_color  ; else {
    if ( i >= 2 ) rColor = E_color  ; else {    
    if ( i == 1 ) rColor = SE_color  ; else {    
    rColor = S_color ; } } } }

return ( rColor );
}
//+------------------------------------------------------------------+

int fDirection( double i, double j)
{
int rColor ;

    if ( i > j ) rColor = 1; 
    else {
    if ( i < j )  rColor = -1; 
    else rColor = 0; }
return ( rColor );
}


//+------------------------------------------------------------------+


string fCompass( double i )
{
string rCompass ;

    if ( i == 5 ) rCompass = Arrow12 ; else {
    if ( i == 4 ) rCompass = Arrow2  ; else {
    if ( i >= 2 ) rCompass = Arrow3  ; else {    
    if ( i == 1 ) rCompass = Arrow5  ; else {    
    rCompass = Arrow6 ; } } } }
    
    
return ( rCompass );
}


//+------------------------------------------------------------------+


//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 

   return(0); 
  } 

int deinit() 
{ 

   
   ObjectDelete("CMP030");
   ObjectDelete("CMP029");
   ObjectDelete("CMP029B");
   ObjectDelete("CMP031");
   ObjectDelete("CMP032");
   ObjectDelete("CMP034");   
   
   ObjectDelete("CMP130");
   ObjectDelete("CMP129");
   ObjectDelete("CMP129B");
   ObjectDelete("CMP131");
   ObjectDelete("CMP132");
   ObjectDelete("CMP134");   

return(0);
}  

//+------------------------------------------------------------------+ 
//| Range                                                            | 
//+------------------------------------------------------------------+ 
int start() 
  { 

double close  = Close[0] ; 
double close1 = Close[1] ; 
double high   = High[0] ; 
double high1  = High[1] ;
double low    = Low[0] ; 
double low1   = Low[1] ;

double mid    = ( high + low )   * 0.50 ; 
double mid1   = ( high1 + low1 ) * 0.50 ; 


double pCount = 0 ;

int   HighDir, LowDir, MidDir, Mid1Dir, CloseDir ;
color CloseColor ;

HighDir  = fDirection( high, high1 ) ;
LowDir   = fDirection( low, low1 ) ;
MidDir   = fDirection( close, mid ) ;
Mid1Dir  = fDirection( close, mid1 ) ;
CloseDir = fDirection( close, close1 ) ;

pCount =  HighDir+ LowDir+ MidDir+ Mid1Dir+ CloseDir ;

CloseColor = fColor( pCount ) ;


string PriceDir = fCompass( pCount ) ;




//+------------------------------------------------------------------+ 

   ObjectCreate("CMP030", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("CMP030","PRICE", 30, "Arial Bold", CloseColor );
   ObjectSet("CMP030", OBJPROP_CORNER, 0);
   ObjectSet("CMP030", OBJPROP_XDISTANCE, 780+price_x_offset); // 760
   ObjectSet("CMP030", OBJPROP_YDISTANCE, 160+price_y_offset); // 160
   

//+------------------------------------------------------------------+ 
/*                     
   ObjectCreate("CMP029", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("CMP029",DoubleToStr(high, Digits ), 15, "Arial Bold", HighColor );
   ObjectSet("CMP029", OBJPROP_CORNER, 0);
   ObjectSet("CMP029", OBJPROP_XDISTANCE, 770+price_x_offset);
   ObjectSet("CMP029", OBJPROP_YDISTANCE, 197+price_y_offset);
 
   ObjectCreate("CMP129", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("CMP129",HighDir, 15, "Wingdings" , HighColor );
   ObjectSet("CMP129", OBJPROP_CORNER, 0);
   ObjectSet("CMP129", OBJPROP_XDISTANCE, 835+price_x_offset);
   ObjectSet("CMP129", OBJPROP_YDISTANCE, 197+price_y_offset);   

//+------------------------------------------------------------------+ 
 
   
   ObjectCreate("CMP029b", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("CMP029b",DoubleToStr( low ,  Digits ), 15, "Arial Bold", LowColor );
   ObjectSet("CMP029b", OBJPROP_CORNER, 0);
   ObjectSet("CMP029b", OBJPROP_XDISTANCE, 770+price_x_offset);
   ObjectSet("CMP029b", OBJPROP_YDISTANCE, 260+price_y_offset);                                      
   
   ObjectCreate("CMP129b", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("CMP129b",LowDir , 15, "Wingdings" , LowColor );
   ObjectSet("CMP129b", OBJPROP_CORNER, 0);
   ObjectSet("CMP129b", OBJPROP_XDISTANCE, 835+price_x_offset);
   ObjectSet("CMP129b", OBJPROP_YDISTANCE, 260+price_y_offset);                 
*/
//+------------------------------------------------------------------+ 
                     
   ObjectCreate("CMP031", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("CMP031",DoubleToStr(close, Digits ), 40, "Arial Bold", CloseColor );
   ObjectSet("CMP031", OBJPROP_CORNER, 0);
   ObjectSet("CMP031", OBJPROP_XDISTANCE, 765+price_x_offset); // 765
   ObjectSet("CMP031", OBJPROP_YDISTANCE, 210+price_y_offset); 

   ObjectCreate("CMP131", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("CMP131", PriceDir , 40 , "Wingdings" , CloseColor );
   ObjectSet("CMP131", OBJPROP_CORNER, 0);
   ObjectSet("CMP131", OBJPROP_XDISTANCE, 930+price_x_offset); // 765
   ObjectSet("CMP131", OBJPROP_YDISTANCE, 210+price_y_offset); 

//+------------------------------------------------------------------+           
/* 
   ObjectCreate("CMP032", OBJ_LABEL, win, 0, 0);   // 
   ObjectSetText("CMP032",DoubleToStr( mid ,  Digits ), 15, "Arial Bold", MidColor ); // RANGEBuffer2[0] buf0[0]
   ObjectSet("CMP032", OBJPROP_CORNER, 0);
   ObjectSet("CMP032", OBJPROP_XDISTANCE, 860+price_x_offset);
   ObjectSet("CMP032", OBJPROP_YDISTANCE, 197+price_y_offset);
   
   ObjectCreate("CMP132", OBJ_LABEL, win, 0, 0);   // 
   ObjectSetText("CMP132", MidDir , 15, "Wingdings"  , MidColor ); // RANGEBuffer2[0] buf0[0]
   ObjectSet("CMP132", OBJPROP_CORNER, 0);
   ObjectSet("CMP132", OBJPROP_XDISTANCE, 925+price_x_offset);
   ObjectSet("CMP132", OBJPROP_YDISTANCE, 197+price_y_offset);

//+------------------------------------------------------------------+ 
                                      
   ObjectCreate("CMP034", OBJ_LABEL, win, 0, 0);
   ObjectSetText("CMP034",DoubleToStr( mid1 , Digits ), 15, "Arial Bold", Mid1Color );
   ObjectSet("CMP034", OBJPROP_CORNER, 0);
   ObjectSet("CMP034", OBJPROP_XDISTANCE, 860+price_x_offset);
   ObjectSet("CMP034", OBJPROP_YDISTANCE, 260+price_y_offset); 
      
   ObjectCreate("CMP134", OBJ_LABEL, win, 0, 0);
   ObjectSetText("CMP134", Mid1Dir , 15,  "Wingdings" , Mid1Color );
   ObjectSet("CMP134", OBJPROP_CORNER, 0);
   ObjectSet("CMP134", OBJPROP_XDISTANCE, 925+price_x_offset);
   ObjectSet("CMP134", OBJPROP_YDISTANCE, 260+price_y_offset);  
//+------------------------------------------------------------------+ 
*/                        

   WindowRedraw();    
 
//} 

   return(0); 
} 
 