//+------------------------------------------------------------------+ 
//|   _TRO_COMPASS_XIND_SW                                             | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpldone@gmail.com                                         |  
//+------------------------------------------------------------------+ 
/*


TOP LEFT is the MAXIMUM Value

BOTTOM LEFT is the MINIMUM Value

TOP RIGHT is the AVERAGE Value

BOTTOM RIGHT is the NUMBER OF BARS CHECKED

BIG NUMBER IS THE CURRENT Value.

*/
#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpldone.com/" 

//---- indicator settings 
#property indicator_separate_window
#property indicator_buffers 0
#property indicator_minimum 0
#property indicator_maximum 1



//---- indicator parameters  
//extern int   Threshold       = 20; 

//extern int win = 1;

extern bool Show_head = true ;
extern int price_x_offset= 0;//250
extern int price_y_offset= 10;//-160

extern int   Chart_Period    = 0;

extern int   MaxBars         = 24;
extern string Ind_Name_1 ="LSMA in Color";
extern string myName     ="LSMA";
extern color  myIndColor = DarkGray ;

extern double iParm3 = 14;
extern double iParm4 = 1500;
extern double iParm5 = -100;
extern double iParm6 = -100;
extern double iParm7 = -100;
extern double iParm8 = -100;
extern int    iMode  = 0;

extern color ColorHeading    =  Gray ; 
extern color ColorValue      = LightGray ; 
extern color ThresholdColor  = LimeGreen; 
extern color ColorABAvg      =  DarkViolet ;    
extern color ColorAvg        =  Orange ;  
extern color ColorABCur      =  Blue ; 
extern color ColorMinMax      =  Chocolate ; 


//---- indicator buffers 


double     MaxValue = 0 ; 
double     MinValue = 0 ; 
double     AvgValue = 0 ; 
double     xValue   = 0 ; 
double     tValue   = 0 ; 

double     zValue   = 0 ; 

//---- buffers


double cVal = 0;

bool  Show_info       = true;
bool  ShowChart       = true; 

double   AboveAvg, BelowAvg, AboveCur, BelowCur ;
string   labelNames;
string   shortName;
int      corner;
int      totalLabels;
int      window;  

//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 
   corner     = 0;
   shortName  = MakeUniqueName("TW ","");
   labelNames = shortName;
      IndicatorShortName(shortName);
   return(0); 
  } 

int deinit() 
{ 
   while (totalLabels>0) { ObjectDelete(StringConcatenate(labelNames,totalLabels)); totalLabels--;}
   return(0);  
}  

//+------------------------------------------------------------------+ 
//| Value                                                            | 
//+------------------------------------------------------------------+ 
int start() 
  { 
  
bool sFirst = true ;

window      = WindowFind(shortName);
   
if ( sFirst ) {
sFirst = false ;
ObjectsDeleteAll( window, 21);
ObjectsDeleteAll( window, 22);
ObjectsDeleteAll( window, 23);
DoHead() ;
}

if(Chart_Period == 0) Chart_Period = Period();

    MaxValue = 0 ; 
    MinValue = 999999 ; 

//   double HighVal,LowVal; 
   int limit; 
   int counted_bars=IndicatorCounted(); 
    
//---- last counted bar will be recounted 
   if(counted_bars>0) counted_bars--; 
   if(counted_bars<0) return(-1); 
   

   AboveAvg = 0 ; 
   BelowAvg = 0 ; 
   AboveCur = 0 ; 
   BelowCur = 0 ;
  
   limit = MaxBars + 1;  

//---- Value counted in the 1-st buffer 


		double buf_tmp = 0 ;
		int z = 0 ;

DoWork(Chart_Period , 0 ) ;
zValue = cVal ;

   for(int i=1; i<limit; i++) 
   { 

DoWork(Chart_Period , i ) ;


     tValue = cVal ; 
     
     buf_tmp =  buf_tmp + cVal ;
 
     
     if( tValue > MaxValue ) {MaxValue = tValue  ; }
     if( tValue < MinValue ) {MinValue = tValue  ; }  
    
     if( tValue > AvgValue ) {AboveAvg = AboveAvg + 1  ; }
     if( tValue < AvgValue ) {BelowAvg = BelowAvg + 1  ; }     

     if( tValue > zValue ) {AboveCur = AboveCur + 1  ; }
     if( tValue < zValue ) {BelowCur = BelowCur + 1  ; }     
                 
   } 

   AvgValue = buf_tmp / MaxBars ; // average 




string tPeriod = " "+TimeFrameToString( Chart_Period ) ;

if ( zValue > AvgValue ) { color ValueColor = ThresholdColor ; } else { ValueColor = ColorValue   ; }

setObject(next(),myName+"("+DoubleToStr(iParm3,0)+")",0+price_x_offset, 0+price_y_offset,ColorHeading ,"Arial bold",15);

setObject(next(),tPeriod,150+price_x_offset, 0+price_y_offset,ColorHeading ,"Arial bold",15);

setObject(next(),DoubleToStr(zValue,Digits),200+price_x_offset, 0+price_y_offset, ValueColor ,"Arial bold",15);               
                 
setObject(next(),DoubleToStr( AvgValue ,Digits),300+price_x_offset, 0+price_y_offset, ColorAvg ,"Arial bold",15);               
  

//string  XIN829 = DoubleToStr( MaxValue ,Digits) + " / " + DoubleToStr( MinValue ,Digits) ;    

setObject(next(),DoubleToStr( MaxValue ,Digits),400+price_x_offset, 0+price_y_offset,ColorMinMax ,"Arial bold",15);
setObject(next(),DoubleToStr( MinValue ,Digits),500+price_x_offset, 0+price_y_offset,ColorMinMax ,"Arial bold",15);


//string  XIN829b = DoubleToStr( AboveCur ,0) + " / " + DoubleToStr( BelowCur ,0) ; 

setObject(next(),DoubleToStr( AboveCur ,0),600+price_x_offset, 0+price_y_offset, ColorABCur ,"Arial bold",15);
setObject(next(),DoubleToStr( BelowCur ,0),650+price_x_offset, 0+price_y_offset, ColorABCur ,"Arial bold",15);     
                 
//string  XIN834 = DoubleToStr( AboveAvg ,0) + " / " + DoubleToStr( BelowAvg ,0) ;   
             
setObject(next(),DoubleToStr( AboveAvg ,0),700+price_x_offset, 0+price_y_offset, ColorABAvg ,"Arial bold",15);               
setObject(next(),DoubleToStr( BelowAvg ,0),750+price_x_offset, 0+price_y_offset, ColorABAvg ,"Arial bold",15);               
            
setObject(next(),MaxBars,800+price_x_offset, 0+price_y_offset, ColorAvg ,"Arial bold",15);               
            
  
      

   WindowRedraw();    
 
//} 

   return(0); 
} 

//+------------------------------------------------------------------+

 
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN1";
   }
   return(tfs);
}
 
//+------------------------------------------------------------------+


void DoWork( int myPeriod , int p )  
{

while(true)
{
if(iParm3==-100 ) {
               cVal = iCustom(NULL,myPeriod,Ind_Name_1,iParm3,iMode,p);
               break ; }
                         
if(iParm3!=-100 && iParm4==-100 && iParm5==-100 && iParm6==-100 && iParm7==-100) {
               cVal = iCustom(NULL,myPeriod,Ind_Name_1,iParm3,iMode,p);          
               break ; }
               
if(iParm3!=-100 && iParm4!=-100 && iParm5==-100 && iParm6==-100 && iParm7==-100) {
               cVal = iCustom(NULL,myPeriod,Ind_Name_1,iParm3,iParm4,iMode,p);         
               break ; }
            
if(iParm3!=-100 && iParm4!=-100 && iParm5!=-100 && iParm6==-100 && iParm7==-100) {
               cVal = iCustom(NULL,myPeriod,Ind_Name_1,iParm3,iParm4,iParm5,iMode,p);
               break ; }                        
            
            
if(iParm3!=-100 && iParm4!=-100 && iParm5!=-100 && iParm6!=-100 && iParm7==-100) {
               cVal = iCustom(NULL,myPeriod,Ind_Name_1,iParm3,iParm4,iParm5,iParm6,iMode,p);
               break ; }                          
            
            
if(iParm3!=-100 && iParm4!=-100 && iParm5!=-100 && iParm6!=-100 && iParm7!=-100) {
               cVal = iCustom(NULL,myPeriod,Ind_Name_1,iParm3,iParm4,iParm5,iParm6,iParm7,iMode,p);
               break ; }
                       
break ;                                          
}

}
string next() { totalLabels++; return(totalLabels); }  

string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
}

void setObject(string name,string text,int x,int y,color theColor, string font = "Arial",int size=10,int angle=0)
{
   string labelName = StringConcatenate(labelNames,name);

      if (ObjectFind(labelName) == -1)
          {
             ObjectCreate(labelName,OBJ_LABEL,window,0,0);
             ObjectSet(labelName,OBJPROP_CORNER,corner);
             if (angle != 0)
                  ObjectSet(labelName,OBJPROP_ANGLE,angle);
          }               
       ObjectSet(labelName,OBJPROP_XDISTANCE,x);
       ObjectSet(labelName,OBJPROP_YDISTANCE,y);
       ObjectSetText(labelName,text,size,font,theColor);
}

void DoHead ()
{
int hSize = 9 ;

              


setObject(next(),"Period",150+price_x_offset, -10+price_y_offset,ColorHeading ,"Arial bold",hSize);

setObject(next(),"Value",200+price_x_offset, -10+price_y_offset, ColorHeading ,"Arial bold",hSize);               
                 
setObject(next(),"Avg Val",300+price_x_offset, -10+price_y_offset, ColorHeading ,"Arial bold",hSize);               
   

setObject(next(),"Max Val",400+price_x_offset, -10+price_y_offset,ColorHeading ,"Arial bold",hSize);
setObject(next(),"Min Val",500+price_x_offset, -10+price_y_offset,ColorHeading ,"Arial bold",hSize);


setObject(next(),"# > Val",600+price_x_offset, -10+price_y_offset, ColorHeading ,"Arial bold",hSize);
setObject(next(),"# < Val",650+price_x_offset, -10+price_y_offset, ColorHeading ,"Arial bold",hSize);     
                  
             
setObject(next(),"# > Avg",700+price_x_offset, -10+price_y_offset, ColorHeading ,"Arial bold",hSize);               
setObject(next(),"# < Avg",750+price_x_offset, -10+price_y_offset, ColorHeading ,"Arial bold",hSize);               
            
setObject(next(),"# Bars",800+price_x_offset, -10+price_y_offset, ColorHeading ,"Arial bold",hSize);           

}