//+------------------------------------------------------------------+
//|                                                    iExposure.mq4 |
//|                   Copyright 2007-2014, MetaQuotes Software Corp. |
//|                                              http://www.mql4.com |
//+------------------------------------------------------------------+
#property copyright "2007-2014, MetaQuotes Software Corp."
#property link      "http://www.mql4.com"
#property strict

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_minimum 0.0
#property indicator_maximum 0.1

#define SYMBOLS_MAX 1024
#define DEALS          0
#define BUY_LOTS       1
#define BUY_PRICE      2
#define SELL_LOTS      3
#define SELL_PRICE     4
#define NET_LOTS       5
#define PROFIT         6
#define PRICE          7
#define DIFF           8
#define PCTRET         9
#define PIPAMT        10
#define MAX           11
#define BE            12
#define AVG           13

extern bool TURN_OFF    = false ; 

extern bool Sound_Alert    = false ; 

extern bool CHANGE_ALL_CHARTS = false ;

extern bool SHOW_ALL_SYMBOLS = true ;
extern string  myAddition = "";



input color TextColor      =  DimGray;  // Text color
input color ProfitColor    =  Green;  
input color LossColor      =  Red;  
input color AskColor       =  Crimson;  
input color AlertColor     =  clrOrange;  

extern color colorButtonBG   =  C'236,233,216' ;
extern string myFont  = "Courier New" ;
extern int myFontSize = 12 ;

extern double myProfitAlert1 = 5.0 ;
extern double myProfitAlert2 = 10.0 ;
extern double myProfitAlert3 = 15.0 ;

string ExtName="Exposure";
string ExtSymbols[SYMBOLS_MAX],OldSymbols[SYMBOLS_MAX];
int    ExtSymbolsTotal=0;
double ExtSymbolsSummaries[SYMBOLS_MAX][14];  // change this when adding columns
int    ExtLines=-1;
string ExtCols[15]={"Symbol",
                   "Deals",
                   "Buy lots",
                   "Buy price",
                   "Sell lots",
                   "Sell price",
                   "Net lots",
                   "Profit",
                   "Current",
                   "Diff",
                   "    ",                      
                   "$Pip",
                   "MAX",
                   "B/E", 
                   "AVG"                
                   };   // change this when adding columns  
//                   0   1   2    3    4    5    6     7   8    9    10    11  12   13  14             
//                   S   DE   BL  BP   SL   SP   NL    P   CUR  DIFF %R   $PI  MAX  B/E AVG
int    ExtShifts[]={ 10, 0,   0,  000, 000, 000, 80,  200, 450, 250, 400, 300, 350, 000, 130  };  // change this when adding columns
int    ExtVertShift=15;
double ExtMapBuffer[];

int    numcol = 15 ;   // change this when adding columns
color  RowColor, SellColor, BuyColor, PriceColor  ; 

double LOTS, pipamount, value1, tickvalue, ticksize, value, margin, bang, balance, tradelots, FreeMargin, profit, MODESPREAD ;

int window;
long chart_id;
color FG, BG, XG, COLOR;
double CLOSE, OPEN, xProfitAlert1 ;   

double buy_lots, sell_lots ,buy_price, sell_price, DAYHIGH, DAYLOW , dem  ;

   int    i,col,line,windex ;
   
//+------------------------------------------------------------------+
void OnInit()
{
	//OnDeinit(1);
	if(TURN_OFF)               { ExtName = ExtName + "   *** INDICATOR OFF ***" ; }  
   else	if(SHOW_ALL_SYMBOLS) { ExtName = ExtName + "   ALL OPEN TRADES SHOWN" ; } 
   	   else                 { ExtName = ExtName + "   *** OPEN TRADES FOR " + Symbol()+  " ONLY ***" ; } 
	

	IndicatorShortName(ExtName);
   SetIndexBuffer(0,ExtMapBuffer);
   SetIndexStyle(0,DRAW_NONE);
   IndicatorDigits(0);
	SetIndexEmptyValue(0,0.0);
	
	windex=WindowFind(ExtName);
	
  for( int u=0; u<SYMBOLS_MAX  ; u++)
  {
      OldSymbols[u] = EMPTY_VALUE ;
  }
	
	
	OnDeinit(1);
	
	ExtLines=-1 ;
 	
}

//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   ObjectDelete("Line_"+"avgprice");
   ObjectDelete("Line_"+"askprice") ; 
   ObjectDelete("Line_"+"alertprice1") ; 
   

   if(windex>0) { ObjectsDeleteAll(windex); }
   
   ExtLines=-1 ;
   TRO();
}
 
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
{

   if( TURN_OFF ) { OnDeinit(0); return(0) ; }

   ObjectDelete("Line_"+"avgprice");
   ObjectDelete("Line_"+"askprice") ; 
   ObjectDelete("Line_"+"alertprice1") ; 
   
   string name, PAIR;
  
   WindowFind(ExtName);
   

  
//----
   if(windex<0) { return(rates_total); }
 
 window      = WindowFind(ExtName);    
 
//---- header line
   if(ExtLines<0)
     {
      for(col=0; col<numcol; col++)
        {
         if(ExtShifts[col] == 0) { continue ; }
         name="Head_"+string(col);
         if(ObjectCreate(name,OBJ_LABEL,windex,0,0))
           {
            ObjectSet(name,OBJPROP_XDISTANCE,ExtShifts[col]);
            ObjectSet(name,OBJPROP_YDISTANCE,ExtVertShift);
            ObjectSetText(name,ExtCols[col],9,"Arial",TextColor);
           }
        }
      ExtLines=0;
     }

      for(int r=0; r<ArraySize(OldSymbols); r++)
      {
         ObjectDelete("Line_"+OldSymbols[r]) ;    
      }   

   ArrayInitialize(ExtSymbolsSummaries,0.0);
   int total=Analyze();
     
   
   if(total>0)
   {


      line=0;
      for(i=0; i<ExtSymbolsTotal; i++)
        {
         if(!SHOW_ALL_SYMBOLS && ExtSymbols[i] != Symbol())  continue;
  
         double current_ask = MarketInfo(ExtSymbols[i],MODE_ASK);
         double current_bid = MarketInfo(ExtSymbols[i],MODE_BID);

         if(ExtSymbols[i] == Symbol()) 
         { 
            ObjectDelete("Line_"+"askprice") ;
            ObjectCreate("Line_"+"askprice",OBJ_HLINE,0,0,current_ask);
            ObjectSet("Line_"+"askprice",OBJPROP_COLOR,AskColor);
            ObjectSet("Line_"+"askprice",OBJPROP_HIDDEN,FALSE);
            ObjectSet("Line_"+"askprice",OBJPROP_STYLE,5);   
         } 

         if(ExtSymbolsSummaries[i][DEALS]<=0) { continue; }
         line++;
         //---- add line
         if(line>ExtLines)
           {
            int y_dist=ExtVertShift*(line+1)+1;
            for(col=0; col<numcol; col++)
              {
               if(ExtShifts[col] == 0) { continue ; }
               name="Line_"+string(line)+"_"+string(col);
               if(ObjectCreate(name,OBJ_LABEL,windex,0,0))
                 {
                  ObjectSet(name,OBJPROP_XDISTANCE,ExtShifts[col]);
                  ObjectSet(name,OBJPROP_YDISTANCE,y_dist);
                 }
              }
            ExtLines++;
           }
      
           
         //---- set line
         
         RefreshRates();
         
         int    digits=(int)MarketInfo(ExtSymbols[i],MODE_DIGITS);
         
         double point= MarketInfo(ExtSymbols[i],MODE_POINT);
  //       if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
         if(digits == 5 || digits == 3) { point = point * 10 ; }  
           


          buy_lots=ExtSymbolsSummaries[i][BUY_LOTS];
          sell_lots=ExtSymbolsSummaries[i][SELL_LOTS];
          buy_price=0.0;
          sell_price=0.0;

 //        double value1, tickvalue, ticksize ;
         
         MODESPREAD  = MarketInfo(ExtSymbols[i],MODE_SPREAD) ;
         tickvalue   = MarketInfo(ExtSymbols[i],MODE_TICKVALUE) ;
         ticksize    = MarketInfo(ExtSymbols[i],MODE_TICKSIZE) ;
         value1      = (tickvalue*point)/ticksize;

         margin      = MarketInfo(ExtSymbols[i],MODE_MARGINREQUIRED) ; 
         balance     = AccountBalance() ;   
         FreeMargin  = AccountFreeMargin() ;  
         profit      =  ExtSymbolsSummaries[i][PROFIT] ;
         
         if( margin != 0.0 ) { tradelots   = 100.00 * FreeMargin / margin ; }
         
         ExtSymbolsSummaries[i][MAX]        = MathFloor( tradelots ) / 100.00 ;           

           
         if(buy_lots > 0)
         {  
            SellColor = TextColor; 
            BuyColor  = ProfitColor;
            buy_price=ExtSymbolsSummaries[i][BUY_PRICE]/buy_lots;
       //     double current_bid = MarketInfo(ExtSymbols[i],MODE_BID);
            ExtSymbolsSummaries[i][PRICE]= current_bid ;            
            ExtSymbolsSummaries[i][DIFF]= current_bid - buy_price ;
            ExtSymbolsSummaries[i][PIPAMT]= value1 * buy_lots;
            dem = value1 * (ExtSymbolsSummaries[i][MAX] + buy_lots) ;
               
            if(dem != 0.0) { ExtSymbolsSummaries[i][BE]= -1.0 * profit / ( dem ) ;  } else  { ExtSymbolsSummaries[i][BE]= 0.0 ; }

            
            ExtSymbolsSummaries[i][BE]= (MODESPREAD * 0.1) + ExtSymbolsSummaries[i][BE] ;
            ExtSymbolsSummaries[i][AVG]=buy_price;
       
            if(ExtSymbols[i] == Symbol()) 
            {  
               ObjectDelete("Line_"+"avgprice") ;
               ObjectCreate("Line_"+"avgprice",OBJ_HLINE,0,0,buy_price);
               ObjectSet("Line_"+"avgprice",OBJPROP_COLOR,BuyColor);
               ObjectSet("Line_"+"avgprice",OBJPROP_HIDDEN,FALSE);
               ObjectSet("Line_"+"avgprice",OBJPROP_STYLE,5);             
  
               ObjectDelete("Line_"+"alertprice1") ; 
               ObjectCreate("Line_"+"alertprice1",OBJ_HLINE,0,0,buy_price+(myProfitAlert1*point) );
               ObjectSet("Line_"+"alertprice1",OBJPROP_COLOR,AlertColor);
               ObjectSet("Line_"+"alertprice1",OBJPROP_HIDDEN,FALSE);
               ObjectSet("Line_"+"alertprice1",OBJPROP_STYLE,5);                                   
         
                     
            }  
 
         }
         else
         if(sell_lots > 0) 
         {
            SellColor = LossColor; 
            BuyColor  = TextColor;
            sell_price=ExtSymbolsSummaries[i][SELL_PRICE]/sell_lots;
   //         double current_ask = MarketInfo(ExtSymbols[i],MODE_ASK);
            ExtSymbolsSummaries[i][PRICE]= current_ask  ;  
            ExtSymbolsSummaries[i][DIFF]= sell_price - current_ask  ;   
            ExtSymbolsSummaries[i][PIPAMT]= value1 * sell_lots; 
              
            dem = value1 * (ExtSymbolsSummaries[i][MAX] + sell_lots) ;
               
            if(dem != 0.0) { ExtSymbolsSummaries[i][BE]= -1.0 * profit / ( dem ) ;  } else  { ExtSymbolsSummaries[i][BE]= 0.0 ; }
   
            
            ExtSymbolsSummaries[i][BE]= (MODESPREAD * 0.1) + ExtSymbolsSummaries[i][BE] ;                     
            ExtSymbolsSummaries[i][AVG]=sell_price;
            
            if(ExtSymbols[i] == Symbol()) 
            {  
               ObjectDelete("Line_"+"avgprice") ;
               ObjectCreate("Line_"+"avgprice",OBJ_HLINE,0,0,sell_price);
               ObjectSet("Line_"+"avgprice",OBJPROP_COLOR,SellColor);
               ObjectSet("Line_"+"avgprice",OBJPROP_HIDDEN,FALSE);
               ObjectSet("Line_"+"avgprice",OBJPROP_STYLE,5);         

 
               ObjectDelete("Line_"+"alertprice1") ; 
               ObjectCreate("Line_"+"alertprice1",OBJ_HLINE,0,0,sell_price-(myProfitAlert1*point));
               ObjectSet("Line_"+"alertprice1",OBJPROP_COLOR,AlertColor);
               ObjectSet("Line_"+"alertprice1",OBJPROP_HIDDEN,FALSE);
               ObjectSet("Line_"+"alertprice1",OBJPROP_STYLE,5);                                   
       
               
            
            } 

         }
         
         ExtSymbolsSummaries[i][PCTRET]= 100 * ExtSymbolsSummaries[i][PROFIT] / AccountBalance()  ; 
         
 //        if( ExtSymbolsSummaries[i][BE]     < 0.0 ) { }
         if( ExtSymbolsSummaries[i][PROFIT] > 0.0)  { RowColor = ProfitColor ; ExtSymbolsSummaries[i][BE] = 0.0 ; } 
         else {RowColor = LossColor ; } 
 
         DAYHIGH  = iHigh(ExtSymbols[i], PERIOD_D1, 0 ) ;
         DAYLOW   = iLow(ExtSymbols[i], PERIOD_D1, 0 ) ;
         
         if( current_ask >= DAYHIGH ) { PriceColor = AlertColor ; } else
         if( current_bid <= DAYLOW )  { PriceColor = AlertColor ; } else 
                                      { PriceColor = RowColor ; } 

 
         if(Sound_Alert)
         { 
            if( ExtSymbolsSummaries[i][DIFF] == myProfitAlert3 ) { Alert( ExtSymbols[i] + " " + DoubleToStr( myProfitAlert3,2 ) ); } else
            if( ExtSymbolsSummaries[i][DIFF] == myProfitAlert2 ) { Alert( ExtSymbols[i] + " " + DoubleToStr( myProfitAlert2,2 ) ); } else
            if( ExtSymbolsSummaries[i][DIFF] == myProfitAlert1 ) { Alert( ExtSymbols[i] + " " + DoubleToStr( myProfitAlert1,2 ) ); }              
         }
/*         
         name="Line_"+string(line)+"_0";
         ObjectSetText(name,ExtSymbols[i],9,"Arial",RowColor);
*/
         name="Line_"+ExtSymbols[i];     
         ButtonCreate(name, ExtSymbols[i],  1, 15+(line*15), myFontSize, RowColor); 
         
         name="Line_"+string(line)+"_1";
         ObjectSetText(name,DoubleToStr(ExtSymbolsSummaries[i][DEALS],0),9,"Arial",TextColor);
         name="Line_"+string(line)+"_2";
         ObjectSetText(name,DoubleToStr(buy_lots,2),9,"Arial",BuyColor);
         name="Line_"+string(line)+"_3";
         ObjectSetText(name,DoubleToStr(buy_price,digits),9,"Arial",BuyColor);
         name="Line_"+string(line)+"_4";
         ObjectSetText(name,DoubleToStr(sell_lots,2),9,"Arial",SellColor);
         name="Line_"+string(line)+"_5";
         ObjectSetText(name,DoubleToStr(sell_price,digits),9,"Arial",SellColor);
         name="Line_"+string(line)+"_6";
         ObjectSetText(name,DoubleToStr(buy_lots-sell_lots,2),9,"Arial",TextColor);
         name="Line_"+string(line)+"_7";
         ObjectSetText(name,DoubleToStr(ExtSymbolsSummaries[i][PROFIT],2),9,"Arial",RowColor);         
         name="Line_"+string(line)+"_8";
         ObjectSetText(name,DoubleToStr(ExtSymbolsSummaries[i][PRICE],digits),9,"Arial",PriceColor);
         name="Line_"+string(line)+"_9";
         ObjectSetText(name,DoubleToStr(ExtSymbolsSummaries[i][DIFF]/point,1),9,"Arial",RowColor);  
 //        name="Line_"+string(line)+"_10";
 //        ObjectSetText(name,DoubleToStr(ExtSymbolsSummaries[i][PCTRET],2),9,"Arial",RowColor);                  
         name="Line_"+string(line)+"_11";
         ObjectSetText(name,DoubleToStr(ExtSymbolsSummaries[i][PIPAMT],2),9,"Arial",TextColor);         
         name="Line_"+string(line)+"_12";
         ObjectSetText(name,DoubleToStr(ExtSymbolsSummaries[i][MAX],2),9,"Arial",TextColor);    
         name="Line_"+string(line)+"_13";
         ObjectSetText(name,DoubleToStr(ExtSymbolsSummaries[i][BE],2),9,"Arial",TextColor); 
         name="Line_"+string(line)+"_14";
         ObjectSetText(name,DoubleToStr(ExtSymbolsSummaries[i][AVG],digits),9,"Arial",RowColor); 
    

        
          // add here when adding columns      
                                     
        }

         for(int q=0; q<ExtSymbolsTotal; q++)
         {
            OldSymbols[q] = ExtSymbols[q] ; 
             
         }

     }
     else
     {
         OnDeinit(1);     // No symbols, delete it all    
     }
//---- remove lines
   if(total<ExtLines)
     {
      for(line=ExtLines; line>total; line--)
        {
         name="Line_"+ExtSymbols[line] ;
         ObjectSetText(name,"");  
         name="Line_"+string(line)+"_0";
         ObjectSetText(name,"");        
         name="Line_"+string(line)+"_0";
         ObjectSetText(name,"");
         name="Line_"+string(line)+"_1";
         ObjectSetText(name,"");
         name="Line_"+string(line)+"_2";
         ObjectSetText(name,"");
         name="Line_"+string(line)+"_3";
         ObjectSetText(name,"");
         name="Line_"+string(line)+"_4";
         ObjectSetText(name,"");
         name="Line_"+string(line)+"_5";
         ObjectSetText(name,"");
         name="Line_"+string(line)+"_6";
         ObjectSetText(name,"");
         name="Line_"+string(line)+"_7";
         ObjectSetText(name,"");
         name="Line_"+string(line)+"_8";
         ObjectSetText(name,"");
         name="Line_"+string(line)+"_9";
         ObjectSetText(name,"");  
          
         name="Line_"+string(line)+"_13";
         ObjectSetText(name,"");   
                     
  //       name="Line_"+string(line)+"_10";
  //       ObjectSetText(name,"");   
         name="Line_"+string(line)+"_11";
         ObjectSetText(name,"");  
         name="Line_"+string(line)+"_12";
         ObjectSetText(name,"");  
                                     
         name="Line_"+string(line)+"_14";
         ObjectSetText(name,"");   
         

           // add here when adding columns        
        }
        
     }
//---- to avoid minimum==maximum
   ExtMapBuffer[Bars-1]=-1;
//----
/*
      for (int z = 0; z < ExtSymbolsTotal; z++)
      {
         PAIR = ExtSymbols[z];  
         OPEN      = iOpen(PAIR,PERIOD_D1,0) ;
         CLOSE     = iClose(PAIR,PERIOD_D1,0) ;
         if(CLOSE >= OPEN) { COLOR = ProfitColor ;} else { COLOR = LossColor ;  }                     
         ButtonCreate("Line_"+PAIR, PAIR,  1, 30+(z*15), myFontSize, COLOR); // RowColor
      } // for  
*/
  
     
  
   return(rates_total);
  }
//+------------------------------------------------------------------+
                                                              
//+------------------------------------------------------------------+
int Analyze()
  {
  // double profit;
   int    i,index,type,total=OrdersTotal();
//----
   for(i=0; i<total; i++)
     {
      if(!OrderSelect(i,SELECT_BY_POS)) continue;
      type=OrderType();
      if(type!=OP_BUY && type!=OP_SELL) continue;
      index=SymbolsIndex(OrderSymbol());
      if(index<0 || index>=SYMBOLS_MAX) continue;
      //----
      ExtSymbolsSummaries[index][DEALS]++;
      profit=OrderProfit()+OrderCommission()+OrderSwap();
      ExtSymbolsSummaries[index][PROFIT]+=profit;
       
      if(type==OP_BUY)
        {
         ExtSymbolsSummaries[index][BUY_LOTS]+=OrderLots();
         ExtSymbolsSummaries[index][BUY_PRICE]+=OrderOpenPrice()*OrderLots();
        }
      else
        {
         ExtSymbolsSummaries[index][SELL_LOTS]+=OrderLots();
         ExtSymbolsSummaries[index][SELL_PRICE]+=OrderOpenPrice()*OrderLots();          
        }
     }
//----
   total=0;
   for(i=0; i<ExtSymbolsTotal; i++)
     {
      if(ExtSymbolsSummaries[i][DEALS]>0) total++;
     }
//----
   return(total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int SymbolsIndex(string SymbolName)
  {
   bool found=false;
   int  i;
//----
   for(i=0; i<ExtSymbolsTotal; i++)
     {
      if(SymbolName==ExtSymbols[i])
        {
         found=true;
         break;
        }
     }
//----
   if(found)
      return(i);
   if(ExtSymbolsTotal>=SYMBOLS_MAX)
      return(-1);
//----
   i=ExtSymbolsTotal;
   ExtSymbolsTotal++;
   ExtSymbols[i]=SymbolName;
   ExtSymbolsSummaries[i][DEALS]=0;
   ExtSymbolsSummaries[i][BUY_LOTS]=0;
   ExtSymbolsSummaries[i][BUY_PRICE]=0;
   ExtSymbolsSummaries[i][SELL_LOTS]=0;
   ExtSymbolsSummaries[i][SELL_PRICE]=0;
   ExtSymbolsSummaries[i][NET_LOTS]=0;
   ExtSymbolsSummaries[i][PROFIT]=0;
   ExtSymbolsSummaries[i][PRICE]=0;   
   ExtSymbolsSummaries[i][DIFF]=0;  
   ExtSymbolsSummaries[i][PIPAMT]=0;    
   ExtSymbolsSummaries[i][MAX]=0;      
   ExtSymbolsSummaries[i][BE]=0;
   ExtSymbolsSummaries[i][PCTRET]=0;   
   ExtSymbolsSummaries[i][AVG]=0;      
     // add here when adding columns  
      
//----
   return(i);
  }

//+------------------------------------------------------------------+

 
void ButtonCreate(string name, string text, int x, int y, int font_size, color font_color)
{
   if(  StringLen(text) > 6 ) { text = StringSubstr(text,0,6) ; }
   
   FG = font_color;
   BG = colorButtonBG ;

   if(myAddition != "") { text = StringSubstr(text,0,StringLen(text)-StringLen(myAddition)); } 
      
   if(Symbol() == text+myAddition) {   XG = FG; FG = BG; BG = XG ; } //else { text = " " + text ; } text = "*" + text ;
   
   if(ObjectFind(0, name) < 0)
   {
      ObjectCreate(0, name, OBJ_BUTTON, window, 0, 0);
   } 
   
   ObjectSetInteger(0, name, OBJPROP_XDISTANCE, x);
   ObjectSetInteger(0, name, OBJPROP_YDISTANCE, y);      
   ObjectSetInteger(0, name, OBJPROP_XSIZE,70);
   ObjectSetInteger(0, name, OBJPROP_YSIZE,14);    
   ObjectSetInteger(0, name, OBJPROP_CORNER, 0);         
   ObjectSetString(0, name, OBJPROP_TEXT, text);
   ObjectSetString(0, name, OBJPROP_FONT, "Arial");
   ObjectSetInteger(0, name, OBJPROP_FONTSIZE, 9);      
   ObjectSetInteger(0, name, OBJPROP_COLOR, FG); // font_color
   ObjectSetInteger(0, name, OBJPROP_BGCOLOR,BG);
   ObjectSetInteger(0, name, OBJPROP_BORDER_COLOR,clrNONE);      
   ObjectSetInteger(0, name, OBJPROP_SELECTABLE, false);
   ObjectSetInteger(0, name, OBJPROP_HIDDEN, false); // true
   ObjectSetInteger(0, name, OBJPROP_BACK,false);
     
  
   ChartRedraw(0);
   
}
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
     
   string PAIR ;
 
   int z ;

   if( TURN_OFF ) {   return ; }   
 
   string           InpName="Button";            // Button name
   ENUM_BASE_CORNER InpCorner=CORNER_LEFT_UPPER; // Chart corner for anchoring
   string           InpFont="Consolas";          // Font  Arial
   int              InpFontSize=11;               // Font size
   color            InpColor=clrBlack;           // Text color
   color            InpBackColor=clrSilver;      // Background color C'236,233,216'
   color            InpBorderColor=clrNONE;      // Border color
   bool             InpState=false;              // Pressed/Released
   bool             InpBack=false;               // Background object
   bool             InpSelection=false;          // Highlight to move
   bool             InpHidden=true;              // Hidden in the object list
                                                           //bool             InpHidden=true;              // Hidden in the object list
   long             InpZOrder=0;                 // Priority for mouse click   
   
/*        
   if(id == CHARTEVENT_CHART_CHANGE)
   {
      for ( z = 0; z < ExtSymbolsTotal; z++)
      {
         PAIR = ExtSymbols[z];  
         OPEN      = iOpen(PAIR,PERIOD_D1,0) ;
         CLOSE     = iClose(PAIR,PERIOD_D1,0) ;
         if(CLOSE >= OPEN) { COLOR = ProfitColor ;} else { COLOR = LossColor ;  }                     
         ButtonCreate("Line_"+PAIR, PAIR,  1, 30+(z*15), myFontSize, COLOR); // RowColor
      } // for  
   }
*/ 
   if(id == CHARTEVENT_OBJECT_CLICK)
   {
      for ( z = 0; z < ExtSymbolsTotal; z++)
      {

          PAIR = ExtSymbols[z];
          if(sparam == "Line_"+PAIR) 
          {
            ChartChange(PAIR);
            break;
          }
      } // for  
 
   }
}

//+------------------------------------------------------------------+  
void ChartChange(string Pair)
{

   long currChart, prevChart=ChartFirst();
   int i=0, limit=100;
   while(i<limit)
   { 
      if(!CHANGE_ALL_CHARTS) 
      {      
         ChartSetSymbolPeriod(chart_id, Pair, Period() ); //  ChartPeriod(prevChart)
         break ;
      }
      
      ChartSetSymbolPeriod(prevChart, Pair, ChartPeriod(prevChart));
      currChart = ChartNext(prevChart);
      if(currChart<0) break;
      prevChart = currChart;
      i++;
   }
}

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string TRO_OBJ    = "TROTAG"  ;  
   ObjectCreate(TRO_OBJ, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(TRO_OBJ, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(TRO_OBJ, OBJPROP_CORNER, 3);
   ObjectSet(TRO_OBJ, OBJPROP_XDISTANCE, 5 );
   ObjectSet(TRO_OBJ, OBJPROP_YDISTANCE, 5 );  
}     
//+------------------------------------------------------------------+
/*


  string comm = "";
  for( int u=0; u<ExtSymbolsTotal  ; u++)
  {
     // if(OldSymbols[u] == EMPTY_VALUE) { break ; }
  //    if(ExtSymbolsSummaries[u][DEALS] < 1) { ObjectDelete("Line_"+OldSymbols[u]) ; }
  //    ObjectDelete("Line_"+OldSymbols[u]) ;
      OldSymbols[u] = ExtSymbols[u] ;
      comm = comm + "\n, u=" + u + " OldSymbols " + OldSymbols[u] ;
      Comment( comm ) ;
      
      if(u>10){ break;}
  }


Comment(

"ExtSymbolsSummaries[0][PCTRET]= ",    DoubleToStr(ExtSymbolsSummaries[0][PCTRET] ,2) , "\n",
" ",    "\n",
 
"") ; 


*/