//+------------------------------------------------------------------+
//|                                                       linreg.mq4 |
//|                                         Copyright  2006, ch33z3 |
//|                                   http://4xjournal.blogspot.com/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2006, ch33z3"
#property  link      "http://4xjournal.blogspot.com/"
//----
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Blue
//----

extern bool TURN_OFF    = false ;
extern bool Show_Labels = true ;

extern int LRPeriod=13;

extern int   LR_Style = 0;  
extern int   LR_Width = 1;  
extern color LR_Color = SteelBlue;  

double ind_buffer[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
 
   IndicatorBuffers(1);
   SetIndexStyle(0,DRAW_LINE,LR_Style,LR_Width,LR_Color);
   SetIndexBuffer(0,ind_buffer);
   
   deinit();
   
   return(0);
  }
 
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int ll = StringLen(Prefix);
   int ii = 0; 
   while(ii < ObjectsTotal())
     {
       string ObjName = ObjectName(ii);
       if(StringSubstr(ObjName, 0, ll) != Prefix) 
         { 
           ii++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
  
                                                         
//+------------------------------------------------------------------+
int deinit()
  {  
  ObDeleteObjectsByPrefix("L/R");
  TRO();
   
   return(0);  
  }                                                             
//+------------------------------------------------------------------+
int start()
{
  
   if( TURN_OFF ) { return(0) ; }  
  
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0)  return(-1);
   if(counted_bars > 0)   counted_bars--;
   int limit = Bars - counted_bars;
   if(counted_bars==0) limit-=1+LRPeriod;
     for(int i=limit; i>=0; i--) 
     {
      ind_buffer[i]=linreg(LRPeriod,i);
     }
     


   if(Show_Labels)
   {         
    
      string Obj0002 = "L/R"+LRPeriod ;

  int Chart_Scale  ,Bar_Width  ;      
  Chart_Scale = ChartScaleGet();
  
  //Set bar widths             
        if(Chart_Scale == 0) {Bar_Width = 120;}
  else {if(Chart_Scale == 1) {Bar_Width = 60;}      
  else {if(Chart_Scale == 2) {Bar_Width = 30;}
  else {if(Chart_Scale == 3) {Bar_Width = 15;}
  else {if(Chart_Scale == 4) {Bar_Width = 8;}
  else {Bar_Width = 4;} }}}}
 
     datetime LabelTime = Time[0]+Period()*60*Bar_Width ; // Time[WindowFirstVisibleBar()/2]; // Time[0]+Period()*60*ShiftLabel ;   
    
      
      ObjectDelete(Obj0002);
      
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, LabelTime, ind_buffer[0]);
         ObjectSetText(Obj0002,fFill("LR("+LRPeriod+")",22) , 8, "Terminal", LR_Color);
      }
      else
      {
         ObjectMove(Obj0002, 0, LabelTime, ind_buffer[0]);
      } // if 
                 
   } // if    
   
      Obj0002 = "L/R-arrow"+LRPeriod ;
      
      ObjectDelete(Obj0002);
      
      if(ObjectFind(Obj0002) != 0)
      {
          ObjectCreate(Obj0002,OBJ_ARROW,0,Time[0],ind_buffer[0]);
          ObjectSet(Obj0002,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(Obj0002,OBJPROP_COLOR,LR_Color);  
      } 
      else
      {
         ObjectMove(Obj0002,0,Time[0],ind_buffer[0]);
      }     
   
     
     
     
   return(ind_buffer[0]);
  }

//+-------------------------------------------------------------------------------------------+
//| Subroutine:  Get the chart scale number                                                   |
//+-------------------------------------------------------------------------------------------+
int ChartScaleGet()
  {
  long result = -1;
  ChartGetInteger(0,CHART_SCALE,0,result);
  return((int)result);
  } 
//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}


    
//+------------------------------------------------------------------+
double linreg(int p,int i)
  {
   double SumY=0;
   double Sum1=0;
   double Slope=0;
   double c;
     for(int x=0; x<=p-1;x++) 
     {
      c=Close[x+i];
      SumY+=c;
     Sum1+=x*c; 
     }
   double SumBars=p*(p-1)*0.5;
   double SumSqrBars=(p-1)*p*(2*p-1)/6;
   double Sum2=SumBars*SumY;
   double Num1=p*Sum1-Sum2;
   double Num2=SumBars*SumBars-p*SumSqrBars;
   if(Num2!=0) Slope=Num1/Num2;
   else Slope=0;
   double Intercept=(SumY-Slope*SumBars)/p;
   double linregval=Intercept+Slope*(p-1);
   return(linregval);
  } 
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string TRO_OBJ    = "TROTAG"  ;  
   ObjectCreate(TRO_OBJ, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(TRO_OBJ, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(TRO_OBJ, OBJPROP_CORNER, 3);
   ObjectSet(TRO_OBJ, OBJPROP_XDISTANCE, 5 );
   ObjectSet(TRO_OBJ, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+
 